2007-07-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 1.6.1
  
  * Added Terracotta support to BasicContinuableClassLoader

2007-07-12  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadoc updates.

  * Bugfix to call continuations to allow any return type for the call method
  call without requiring a cast.

  * Added capability to BasicContinuableRunner to directly answer a
  continuation, and to postpone the answering too.

  * Fixed race condition in the basic continuations classloader.

  * Added check and test for the ordinal restriction value to be not null.

2007-07-11  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for getInputDate to ElementSupport.

2007-07-02  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated RIFE version to 1.6.1-snapshot.

  * Renamed Eclipse run targets.

  * Fixed regression bug with LightweightError.

  * Improved BasicContinuableRunner to make it more flexible.

2007-06-28  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 1.6
  
  * Updated changelog.

  * Updated and enhanced IDE project files.

2007-06-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor improvement to template deployment to reduce the requirements.

2007-06-25  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Finished continuations API and javadocs.

  * Added byte code instrumentation agent for continuations package.

2007-06-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Simplification of the continuations API by removing the
  ContinuationContextProvider interface.

  * Continuations refactoring to remove static setup method calls.

2007-06-23  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added more javadocs for the continuations package.
  
  * Added tests for the interface-only usage of continuations with a dedicated
  ContinuableSupport class that is used during the tests.

  * Radical improvements to memory usage with clustered continuations through
  Terracotta

2007-06-22  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Changed terracotta detection to use the name tc.active system property.

  * Updated syntax highlighting for the examples

2007-06-21  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Improved javadocs.

  * Continuations fixes for Terracotta

2007-06-20  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Refactored answers to call continuations so that it doesn't rely on too
  much boilerplate logic.

  * General continuations API cleanup and simplification.

  * Refactored basic continuable runner into its own package and made the call
  target retrieval customizable.

2007-06-19  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Reworked call continuation answering so that it doesn't rely on the web
  engine.

  * Included simple call continuation test for the dedicated continuations
  package.

  * Some minor Terracotta related fine-tuning.

  * Fixes to Terracotta support.

  * Further refactorings to continuations package.

2007-06-18  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Refactorings to make the continuations method names 'pause', 'stepBack'
  and 'call' configurable.

  * Cleanups for the basic continuable runner

2007-06-17  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added tests and support for stepback in continuations package.

2007-06-12  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Refactorings and cleanups to the continuations package to make it easier
  to use, configure and comprehend.

  * Removing continuations agent test, since the agent is currently not
  customizable for custom ContinuableObject classes.

2007-06-11  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added test ant target for agent.

  * Added ant target for building just the continuations functionalities as a
  jar.

  * Added ant target to run only the continuations tests with just that jar
  and nothing else of RIFE.

  * Global refactorings to reduce dependencies of the continuations package on
  the rest of the framework.

  * Minor regression fix to Validation cloning.

  * RIFE-271 : Add new BA tag to the template engine

  * Upgraded Spring to 2.0.5 and XFire to 1.2.6.

2007-06-10  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Upgraded MVEL to 1.2.0b21, Rhino to 1.6R5 and Janino to 2.5.7

  * RIFE-339 : Value of globalvar cannot be set during a continuation

  * Upgraded to JRuby 1.0

2007-06-07  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor RIFE fix for improved Terracotta compatibility.

  * RIFE-340 : Include tags with mixed text delimiters are wrongly parsed

  * RIFE-338 : Text that begins with template tag beginnings are now
  incorrectly picked up

2007-05-19  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixes to the template parser with regards to the optional quotes.

2007-05-14  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Upgraded DWR to 2.0.1

  * Fixes to manyToOne declaration inspections.

2007-05-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Upgraded to MVEL 1.2

2007-05-12  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed regression issue where manyToOne columns with basic data types
  weren't handled as they were before.

2007-05-08  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated Javadocs.

  * RIFE-307 : Ignore quotes in ${v} template tags

2007-05-06  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RIFE-325 : No way to set database table name in ContentQueryManager

2007-05-05  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RIFE-280 : Add support for manyToMany

2007-05-03  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Source cleanup with regards to the detection of Terracotta presence.

  * Added some synchronization locks.

2007-05-02  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added Terracotta tc-config.xml files for all the examples with shared
  state.

  * Updated examples for Terracotta.

  * Made some small fixes to RIFE itself for better Terracotta support.

2007-05-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Upgraded Spring to 2.0.4 and added some missing license texts.

  * Upgraded XFire and related libs.

  * Upgraded SubEtha SMTP and SubEtha Wiser to 1.2

  * Upgraded DWR, ImageroReader and PostgreSQL JDBC

  * Upgraded JRuby (including ASM and Backport), Janino, Pnuts, H2

2007-04-30  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Upgraded H2 support to version 1.0-2007-04-29.

  * Added support for saving manyToOne collection associations.

2007-04-29  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadoc fixes

2007-04-28  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added IdentifiableUsersManager that contains the methods that are needed
  by the Identified element to identify a user.

2007-04-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated synchronization for Terracotta compatibility.

  * Small fix to field incompatibility reporting when using using annotations
  for declarations.

2007-04-17  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added and expanded Jeremy Cowgar's hex version of the string encryption
  schemes.

2007-04-12  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Performance improvements to manyToOne and manyToMany so that only
  Constrained classes that have related ConstrainedProperties will be
  further examined. Classes that don't declare relational constraints will run
  just as fast as before with the GenericQueryManager.

2007-04-11  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for manyToOne collection associations lazy restoring, still
  needs to support other database operations and validation.

2007-04-08  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added another continuations test

  * Added first dedicated non-engine continuations test.

  * Refactored continuations API.

  * General testcase fixes to correctly run in another timezone.

2007-04-05  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated terracotta config

2007-04-03  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Regression fix to continuations without agent instrumentation

  * Split up continuation config into a runtime and an instrumentation part,
  so that the continuations instrumentation agent doesn't need to rely on the
  imported runtime classes.

2007-03-29  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Totally separated continuations from the web engine. Needs javadocs,
  dedicated tests, more cleanup and refactoring to make the API as easy as
  possible

2007-03-28  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Initial refactoring to put continuations in their own package, not
  entirely separated from RIFE web engine yet.

2007-03-20  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * A whole collection of minor bugfixes related to the latest added features.

  * Much improved example 8, advanced continuations.

2007-03-19  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fix to meta data merging to support OpenTerracotta

  * Added rife.instrumentation.dump system property support that will cause
  the initial and the adapted versions of class's bytecode to be dumped to
  files in the user's home directory.

2007-03-18  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Regression fix for bad imports in some test classes

  * RIFE-314 : Need a way to cancel continuations on exit/submission
  declarations

2007-03-17  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor regression fix to tests

2007-03-16  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor regression fix to beanutils

  * Regression fix to EngineClassLoader

  * RIFE-215 : Added support for Java 5.0 enum types as bean properties

  * Added enum inList support for CreateTable.

  * Fixed an issue with NULLs and generating the check constraint SQL for
  inList constraints.

  * Added Java 5 enum support to database layer

2007-03-14  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated RetroWeaver to v2.0 and adapted it for inclusion into the RIFE 1.4
  with a dedicated runtime package to prevent conflicts

  * Added enum support to web engine.

  * Regression fix to memory authentication session purging

2007-03-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RIFE-319 : java.util.Date in named output bean does not get through

  * Fixed JDK 1.6 support

2007-03-10  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RIFE-303 : Property name annotations attribute

2007-03-09  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RIFE-306 : Add "comment" template tag

2007-03-08  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadoc improvements

  * RIFE-332 : Without a ParticipantConfig file upload paths get set to
  "null/"

2007-03-07  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added fully working version of the RIFE instrumentation agent

2007-03-05  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added meaningful exceptions for DWR deployment when the config file is
  wrong

2007-03-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Created ClassBytesLoader to provide a dedicated class for class bytes
  loading

  * Added agent support for meta data merging

2007-03-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * First support for a RIFE instrumentation agent, currently only supports
  continuations functionalities

2007-02-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Merged changes from Terracotta branch r3658:3673 into trunk

  * Ant build file fix

  * Added shorthand manyToOne constraint support where association class and
  column are automatically detected.

2007-02-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for real many to one relationships in the GQM which
  instances can be property values and are lazily loaded. Still need some
  cleaning up and javadocs.

  * Engine classloader refactorings for code clarity.

  * Unittest improvements for serialized beans that assumed classes that were
  compiled by X-develop.

2007-02-16  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added initial support for manyToOne properties that contain the entities
  itself instead of the identifier values. Lazy loading isn't implemented yet,
  neither is shorthand manyToOne constraint declaration without any arguments.

2007-02-06  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadoc updates

2007-01-29  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for unionAll in Select queries.

  * Added support for query hints to Select, Insert, Delete and Update queries
  (only applicable to Oracle and MySQL)

2007-01-19  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for ReadQueryTemplate so that custom SQL queries can be
  aggregated into templates as named blocks.

  * Added ReadQueryString implementation so that any custom SQL query can
  benefit from the RIFE wrappers.

2007-01-17  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Small source restructuring in the EngineClassLoader for clarity.

2007-01-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated MVEL to 1.1.5 and added support for compiled expressions

2007-01-12  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Furthered refactored authentication to be fully backwards compatible with
  the earlier release but still be entirely pluggable.

  * Refactored authentication managers to be independent of the engine
  ElementInfo.

  * Fixed bug with template printing and cloning when there are expression
  block values present.

2007-01-09  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor typo fix in ConstrainedProperty

  * Updated Firebird support to use Jaybird 2.1.1 and tested in on
  Firebird 1.5.3 MacOSX Intel

2007-01-08  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated copyright year to 2007

  * Added support for EXIT:PARAMSJS:exitname and
  SUBMISSION:PARAMSJS:submissionname to generate the hidden form fields
  through javascript with ascii code obfuscation to that spammers have a much
  harder time to detect what actually goes on.

  * Minor improvement to repository properties so that system properties
  always sit in their own instance of the HierarchicalProperties tree.

  * Small improvement to DWR integration to only allow java identifiers for
  the DWR container properties.

2007-01-07  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fix to DWR integration to not included system properties into the DWR
  container that is setup at deployment 

2007-01-04  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated DWR to version 2.0RC2

  * Updated JDeveloper project files

  * Upgraded Hessian to version 3.0.19, which is currently the most recent
  version that works correctly.

2007-01-03  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor Javadoc fix

  * Fix for WEBAPP_ROOT_PATH

  * Minor fix to engine element reload tests.

  * Added support for a WEBAPP_CONTEXT_PATH configuration parameter.

  * Engine Gate refactoring.

  * Added findElementForRequest method to Site.

  * Improved DWR support so that reverse Ajax would work correctly.

  * Updated Groovy to v1.0 final

2007-01-02  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor fix to HTML entity decoding

  * Added support for HTML entity decoding to StringUtils.

  * Improved aggresive HTML encode to use numeric entities for those
  characters that don't have a literal entity declaration.

2006-12-31  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor source cleanup for DWR support

2006-12-29  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Finished adding support for DWR 2.0RC1.

  * Added tests for validating the integration of DWR into RIFE.

  * Upgraded to MVEL 1.1.02

  * Added support for MVEL as an expression language for template blockvalue
  scripting.

2006-12-23  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated Groovy to 1.0RC2

2006-12-21  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added additional Ant command line bin items

  * Upgraded included Ant to version 1.7.0.

  * Javadoc improvements and fixes.

  * Added preliminary support for compilation with JDK 1.6.

  * Code cleanups.

  * Extraction of Java specification detection functionality.

  * Ant build refactoring.

2006-12-20  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Upgraded and tested Derby to version 10.2.2.0

  * Added support back for scripted elements in JRuby.

  * Fixed performance problem with Groovy script caching.

  * Added fix for running RIFE without a default repository and accessing
  the properties

2006-12-18  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added exception that checks for a missing getter for a constrained
  property before using it.

2006-12-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated continuation manager to enforce a hard timeout on the continuation
  expiration time. When a continuation context is now obtained, it will only
  be retrieved when its time hasn't been expired yet.

2006-12-06  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added getFullName() to the Template interface and implementation.

  * Upgraded Groovy to 1.0 RC 1

  * Commented out the default empty string datasource property in the database
  logout element declaration

  * Commented out the default empty string datasource property in the database
  authentication element declaration

2006-12-04  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * First working version of many-to-many support in the generic query manager

2006-11-11  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fix to make the bean handler of text templates behave exactly as the one
  for xhtml template, for the exception of form building

2006-10-23  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added @Elem annotation to each standard element implementation so that
  they can be used easily in a default fashion.

  * Replaced all assertTrue(false) calls in the tests with fail()

2006-10-21  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Upgraded XFire to version 1.2.2 and updated the support for the changed
  APIs

  * Added complete support for the H2 database v1.0.

  * Upgraded Spring to v2.0

2006-10-20  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Upgraded to latest revision of Pnuts 1.1.

  * Upgraded Rhino to version 1.6R4.

  * Upgraded Janino to v2.5.0

  * Upgraded Tcl/Java to v1.3.3 and added support for its new exception
  handling mechanism.

  * Upgraded ImageJ and ImageroReader

  * Replaced Dumbster 1.6 by SubEtheSmtp Wiser 1.1 to test the asynchronous
  mail queue.

  * Upgraded hsqldb to version 1.8.0.7

  * Upgraded DaffodilDB to version 4.1

  * Upgraded Derby to version 10.2.1.6.

  * Fixed some regression issues with the test suite.

2006-10-19  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added better support for element field annotations, they have to be static
  now and don't need an instance of the element to be able to be instantiated,
  hence allowing for abstract elements.

  * Added better support for automatic ID and URL generation for annotated
  elements that extend other annotated elements.

2006-10-17  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Made charset detection more permissive

  * Bugfix for Content-Type headers in HttpUtils that are suffixed with
  ;charset= instead of ; charset

  * Added support for L&F detection of JGoodies Looks v2

2006-09-29  Steven Grimm  <koreth[remove] midwinter dot com>

  * RIFE-313: Scheduler job to probe database connections periodically. Can
  be used to keep MySQL from timing connections out.

2006-09-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Merged in Steven Grimms authentication refactoring that brings total
  pluggability and loose coupling of all the managers. Merged up to
  revision 3529.

2006-09-20  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Removed the methods that return List from the Participant interface

2006-09-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added tests for new form builder API methods.

  * Cleaned up the source code a bit thanks to IDEA's inspections.

2006-09-14  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added different property template name support to FormBuilder.

  * Added full FormBuilder javadocs.

2006-09-05  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added ValidationContext support to validateGroup.

  * Updated Oasis Catalog of RIFE DTDs.

  * Fixed URL encoding bug in CMF ServeContent element.

2006-09-02  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Removed all IllegalArgumentExceptions on names since they are not
  critical, they now just return false or null, which are possible return
  value anyway if a non existing name is provided.

2006-09-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Workaround to handle Jetty's custom tx resource protocol

2006-08-17  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated wrong site DTD System ID

2006-08-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Removed Axis configuration params, since we're using XFire now for SOAP

2006-08-14 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 1.5.1

2006-08-14 Steven Grimm (koreth[remove] at midwinter dot com)

  * RIFE-301 : Allow pass-through of unauthenticated users in Authenticated
  element

2006-08-14 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Replaced "since 1.6" by "since 1.5.1"

  * RIFE-204 : Adapt pretty engine errors to XML content type

  * Fixed bug where JNDI datasources didn't detect the driver name when
  database functionalities are used before an actual connection is made
  through the datasource.

2006-08-12 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RIFE-269 : New autolink element to simplify datalink definitions

2006-08-10 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added better auto-recompilation support for annotation elements. It now
  works even if they were initially compiled through the IDE.

  * Class loader fixes to prevent stack overflow errors with class lookups of
  inexistant classes.

  * Added some ensurances to unregister a thread connection at all times
  during cleanup and connection errors

2006-08-09 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added instant modification check in case an exception was thrown, that
  should prevent the 10 second delay each time you want to check if an
  exception has been resolved

  * OrdinalManager transaction fix

  * RIFE-302 : Element declaration annotations from parent classes are ignored

2006-08-07 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Corrected some problems and sub-optimal code after looking at some of
  IDEA's inspections.

2006-08-04 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for BigDecimal in bean property setting.

  * Added support for the 'format' constraint to bean property injection for
  all numeric types.
  
  * Made ContinuationContext.getElement public.
  
  * Re-activated finally continuations test since JDK 1.5 is pretty baseline
  nowadays

2006-08-02 Steven Grimm (koreth[remove] at midwinter dot com)

  * RIFE-299 : Logout element doesn't work with global rememberid cookie

2006-07-31 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RIFE-297 : Global cookie can't be used for rememberid

2006-07-29 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fix for the RifeServlet to be usable at other URL mappings than /*.
  Sadly, RifeFilter can't do this, since no distinction is made by the
  servlet spec between the servlet path and the pathinfo when using filters.

2006-07-21 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support to validate array property values in standard validation
  rules.

2006-07-20 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixes to element recompilation when using manual site declarations in
  Java.

2006-07-18 Steven Grimm (koreth[remove] at midwinter dot com)

  * RIFE-292 : Document that query objects can be passed to DbQueryManager

2006-07-18 Steven Grimm (koreth[remove] at midwinter dot com)

  * RIFE-293 : Allow multiple config file selectors

2006-07-17 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added proper support for submission bean date arrays and serializable
  arrays.

2006-07-13 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 1.5

2006-07-12 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated mime type property for the examples highlighted source code.

  * Updated changelog

2006-07-11 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Placed empty target types on annotations that can only be used nested
  inside enclosing annotations.

  * RIFE-284 : @Exit annotation should be valid on fields

  * Ant build file fixes

2006-07-10 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor refactorings concerning state store extensibility

  * Generated highlighted sources of the latest version of the examples.

  * Example refactoring and source code re-formatting

  * Changed the dominant template tag syntax in the examples into
  <r:v name=""/>

  * Very rare NPE fix.

  * RIFE-291 : Annotation destClass attributes should also support a
  destClassIdPrefix attribute

2006-07-09 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Compilation fixes for windows and environment setup fixes for windows.

  * Tmp path fixes

  * Updated project files.

  * RIFE-281 : INVALID should suppress/clear MANDATORY message
  
2006-07-08 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Upgraded Janino to version 2.4.5

  * Upgraded to Imagero Reader 1.9.1-1, PostgreSQL JDBC 8.1-407, Spring 1.2.8

  * Upgraded bundled Derby to version 10.1.2.1 and
  Groovy to version 1.0 JSR 06

  * RIFE-286 : RIFE should support @Priority annotations for method and
  field annotations on elements.
  
  * Minor cleanups and javadoc fixes to BlockingRepository and
  HierarchicalProperties.
  
  * Added tests for HierarchicalProperties

2006-07-07 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support to hierarchical properties for easily adding a map.

  * Convenience API updates to BlockingRepository.

2006-07-06 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fix to template bean setting where the format constraint wasn't fully
  respected.
  
2006-07-05 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Some LightweightEngineException fixes for Rhino engine

  * Regression fix related to making LightweightEngineException extend Error,
  they weren't properly dispatched inside submission handlers.
  
  * Addition of convenience methods to the BlockRepository.

2006-07-03 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for setting exceptions as "rife.engine.exception" request
  attributes, so that servlet API 2.4 dispatch rule handlers can use it.

  * Replaced some 1.5 API calls with 1.4 counterparts.
  
  * Made other returned collections in templates also unmodifiable.

2006-07-02 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Ensured returned lists of Template getFilteredValues and getFilteredBlocks
  into unmodifiable lists.

  * Bugfix related to the inheritance and precedence order of complex nested
  groups and subsites.

2006-06-30 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added USE_FAST_EXCEPTIONS configuration parameter to allow people to turn
  on the full strack traces when having to debug weird exception behavior.
  By default it is true.

  * RIFE-288 : Can have two unnamed submission beans with XML declaration but
  not with annotations

  * RIFE-287 : Embedded elements don't inherit parents' authentication data

2006-06-28 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Changed CMF content serving to call ElementSupport.defer() instead of
  setStatus(HttpServletResponse.SC_NOT_FOUND). This means that the CMF URL
  space can be shared with other filters or even with static files in the
  web application directory.

  * Made LightWeightEngineException an Error instead of a RuntimeException.
  This should reduce the probability of people catching it accidentally.

2006-06-27 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added fix for relative element ID resolving for arrival elements. Instead
  of using the real ID of the arrival, the resolving now happens against the
  ID of the reference element to where the arrival points.

2006-06-26 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * API fix to SubmissionBuilder.
  
  * Made Annotations2ElementInfo work if the element processor type is
  annotations, but there's no @Elem annotation on the class.
  
  * Added support for cloning blueprint instances to create new Element
  instance, instead of having to only rely on instantiating them from the
  class. This is needed to be able to support elements that are implemented
  through anonymous inner classes.
  
2006-06-20 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Performance improvements by caching the injection setter methods for each
  element.

  * Replaced all StringBuffer occurances by StringBuilder and removed the
  thread lock pre-allocations that was needed to achieve a speed increase with
  StringBuffer. RetroWeaver translates all StringBuilder occurances back to
  StringBuffer to make the jar usable on JDK 1.4 (though a bit slower).

  * Added support for StringBuilder where StringBuffer is support for SQL
  conversion and such.

  * Performance optimizations.

  * Stateful embedded element fix that occurred when mixing early embedded
  value tag processing with explicit late processing of the same value ID and
  element differentiator.

2006-06-16 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Made the embed value of embedded elements now always only use the template
  default value instead of the template value (which can change). To pass data
  to an embedded element, an embedding element can provide a data object to
  processEmbeddedElement.

  * Build file fix for examples

2006-06-15 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated SVN properties

2006-06-12 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added some logic to ensure that state stores always have the correct type
  after cloning their container.

  * Regression bugfix with form general for exits without outputs.

2006-06-09 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 1.5M2 (milestone 2)

  * Updated changelog

  * Updated javadocs

  * Updated highlighted syntax for the game example

2006-06-08 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Refactoring of state storage to improve session state handling.

2006-06-07 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added test for parallel embedded continuation elements.

  * Made session state storage more performant.

  * Added support for not cloned session state storage to reduce the session
  size (SESSION_STATE_STORE_CLONING config param).

  * Fixes to session state storage.

2006-06-06 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Refactored state storage strategies to make session state storage much
  more performant.

2006-06-05 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for simultaneous continuations in different embedded
  elements.

2006-06-02 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor bugfix to game example

2006-05-29 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed a bug related to embedded element processing with differentiators.

2006-05-26 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added GenericQueryManager listeners.
  
  * Added support for the "content-type" content attribute to all content
  stores, so that the content type can always be tailored for content
  serving.

2006-05-23 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixes to stateful components.

2006-05-19 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Made the advanced continuations example cleaner and easier to look at.

2006-05-17 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added better support for continuation tree invalidation.

2006-05-16 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Made request and response encoding easily configurable with
  REQUEST_ENCODING and RESPONSE_ENCODING config parameters.

2006-05-13 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 1.5M1 (milestone 1)

  * Renamed hsqldb jar according to its version number.

2006-05-12 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added stateful embedded elements explicit processing test.
  
  * Bugfix to stateful embedded elements.

2006-05-11 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added test for embedded element data passing.

2006-05-09 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated activation, javamail, dwr, janino, ognl, postgresql jdbc, hsqldb
  and pnuts jars.

  * Added support for smpt_from task option to mail queue executor to set the
  from envelope address for mail envoys.

  * Regression bug fix to CMF ServeContent element.

2006-05-08 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Restored previous Template.getValue return type and
  ElementSupport.getEmbedValue return type.

  * Updated version to 1.5-snapshot

  * Removed some directories.

  * Updated examples syntax highlighting and moved the resulting html files
  to a dedicated directory to avoid confusion with the actual source files

  * Minor example structure rearrangements and fixes.

  * Fixes to annotation element declaration support.
  
  * Fixes for stateful embedded elements.
  
  * Added hangman example.

2006-05-07 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * X-develop project file fix

  * Added stateful component example

2006-05-06 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added testcase for stateful embedded elements.

2006-05-03 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Re-implemented stateful component support. It now works exactly as
  expected when coming from other component frameworks.

2006-04-30 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Code cleanups.

  * Added support for stateful embedded element instances.

2006-04-27 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor fix to defer.xml element and minor code cleanups.

2006-04-24 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Made standard template factories non final.

  * Updated SVN mime types

  * Updated numberguess example

2006-04-23 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Finished javadocs for element declaration annotations.

2006-04-22 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added more javadocs for element declaration annotations.

2006-04-21 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for reloading manual site declarations through
  notifications of SiteListeners.

  * Added javadocs.

2006-04-20 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadoc additions for element declaration annotations.
  
  * Refactoring of the Site class internals to make it more maintainable.

2006-04-19 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadoc additions

  * Bug fixes to automatic site structure reloading.
  
  * Added support for auto-reloading of continuations-able classes.
  
  * You should now be able to use hot-swap to indicate a modified element
  java class and RIFE will auto-compile it, allow hot reloading of class
  structure changes that are not yet supported by hot-swap. You can ignore
  your IDEs warning.

  * Made bean property processing use a predictable order, ie. the order in
  which the properties are defined in the source file of the bean class.

2006-04-18 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * NPE fix to MetaData handling.

  * Updated authentication example to use global cookies instead of global
  vars.

  * Added duringStepBack() method that can be used if a step-back
  continuation happened right before.

  * Fix to stepBack continuations.
  
  * Made the submission parameters validation check all the submissions, not
  just the active one.

  * Improvements and javadoc additions for element declaration annotations

2006-04-17 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Improvements and javadoc additions for element declaration annotations

2006-04-15 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for 'stepBack' continuations.

  * Improved error reporting during repository startup in the RIFE servlet
  or filter

2006-04-14 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Bugfix related to annotations and continuations in element
  implementations

  * Upgraded ASM to v2.2.2

  * Fixed issues when extending MetaData and using submission beans, inbeans
  or outbeans with constraint groups.

  * Opened up some of the ContinuationsManager and ContinuationsContext API.

  * Fixed flowlink-specific datalink bug. When several had the same output,
  input and target element, only one was taken into account due to incomplete
  hashCode and equals methods.

2006-04-13 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed to the project and the annotations to make this work with X-develop

2006-04-13 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor config change for MacOSX

2006-04-12 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated DWR to 2.0M1.

  * Rewrote the DWR integration element and deployer for the new DWR version.

2006-04-06 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor reconfigurations for running on windows

2006-04-05 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Bugfix related to element tracing and continuations.

2006-04-04 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added outcookie outjection support, fixes to output outjection. This
  finalizes RIFE element bijection support.

2006-04-03 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for output value listener notification from getter
  outjection.

  * Added inheritance and child trigger support to output and outbean
  outjection.

2006-04-02 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added outbean outjection support

2006-04-01 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Performance optimizations for injection into element instances

  * Added support for output outjection.

2006-03-30 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Upgraded XFire, Pnuts, Spring, Javamail, Janino, ImageJ, ImageroReader to
  their latest versions

2006-03-28 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Test suite fixes

2006-03-27 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for cookie injections. Added also tests for defaults in
  parameter injection.

  * Minor bugfix on mail queue for robustness

2006-03-26 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added injection support of named input beans, named submission beans and
  uploaded files.

2006-03-22 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added dedicated exceptions for annotations support for element
  declaration.

2006-03-21 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed bug related to global vars and sibling embedded elements.

2006-03-20 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated SVN props

2006-03-16 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added PROPERTY:name filtered value tags

2006-03-15 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Template auto reload regression fix

  * Updated DWR and integrated Joe's patch

2006-03-14 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added standard rife/defer.xml and com.uwyn.rife.engine.elements.Defer
  element

  * Updated example source code syntax highlights

2006-03-12 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added tests for auto reload delay and minor fixes to template auto reload
  delay.

2006-03-11 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Replaced uses of Calendar.getInstance() with either new Date() or
  System.currentTimeInMillis() where appropriate.

  * Added a system-wide auto reload check delay that's by default 10 seconds.
  The configuration parameter AUTO_RELOAD_DELAY can be used to change it.

  * Bugfix to element declarations and 'extends'

2006-03-10 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added classloader magic to hot reload annotations after hotswap.

  * Added check for missing element declaration and now throwing a meaningful
  exception.

  * Further work on element annotations.

  * Updated X-develop project file.

  * Added JDeveloper project files.

  * Removed unnecessary code.

2006-03-10 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added experimental work in progress support for Element annotations.

  * NPE fix to IoC.

  * Added lifecycle.classname init parameter for the RIFE filter / servlet
  so that people can opt to extend the RifeLifecycle class and implement a
  Lifecycle in pure Java without relying on XML. With this step, a RIFE
  application can be written without a single line of XML.

2006-03-09 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixes to IoC properties declarations inside the repository declaration.

  * Regression fix to meta data merging.

2006-03-08 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed meta data merging for classes with annotations.

  * Fixed instrumenting of annotations in continuations.

2006-03-06 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Workaround for bug in MySQL 5 on Windows that reports BIT columns as
  being VARCHAR.

2006-03-04 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RIFE-275 : URLs for pathinfo mappings with globalvars are incorrect

2006-03-02 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * NPE fix in bean handling.

2006-03-01 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor change to the site.dtd.

2006-02-27 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * MetaData bugfix with regards to X-develop's debug compilation.

2006-02-26  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 1.4

  * RIFE-262 : Add full POJO support for constraints declarations.
  Finalized the implementation by adding support for auto-implementation or
  modification of the clone() method so that the bean instance and the
  meta-data instance always stay together and that clones are properly
  isolated.

  * Updated changelog and project files.

2006-02-25  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added javadocs.

  * Renamed some methods to prevent them from being seen as bean properties

  * Updated project files.

  * Upgraded Groovy

  * Fixed MetaData bugs.

  * Made MetaData fully lazy instantiating.

  * Added ValidatedConstrained interface.

  * Changed JavaDocs version 1.3.2 into 1.4

2006-02-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added first working version of pure POJO support with automatic meta data
  merging

  * Added DTD for regular tag template syntax.

  * Added teglib descriptor for making the regular template tag syntax
  understood by tools.
  
  * Updated all DTDs to be in UTF-8 encoding.

  * Updated all examples to use the Velocity template syntax instead.

2006-02-23  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added experimental Ajax DWR support

  * Added support for the Velocity-inspired tag syntax

  * Added support for regular html tags for doing RIFE markup in the xhtml,
  xml, html templates.

  * Optimized the parsing algorithm to work a lot faster with numerous configs:
  an initial scan is first performed to detect the syntax variationts that are
  in use, and only those will remain for the actual parsing.

2006-02-22  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Explicit embedded element processing bugfix

  * NPE fix

2006-02-21  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated highlighting of example sources

  * Friend example update

2006-02-17  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor test suite fixes.

  * CMF fixes for RAW content storage with Derby and MySQL.

  * RIFE-244 : Add API for "manually" invoking authentication

  * RIFE-193 : Add public API for filling bean with submission values
  (name-value pairs)

2006-02-16  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RIFE-253 : <site> should not require "file" attribute

  * Added some convenience methods to the CMF

  * Added support for dynamic repository names to the ServeContent element.

  * RIFE-264 : Embedded elements do not received pathinfo inputs : Embedded
  elements now receive all inputs of the embedding elements as if they were
  regular request parameters.

  * Added support for strict pathinfo mapping.

  * Added support for several elements with the same pathinfo URL.

2006-02-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Reduced memory usage for wordwrap

2006-02-14  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added wordWrap method to StringUtils.

2006-02-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Deprecated CmfProperty and CmfValidation, moving all their logic into the
  base classes.

2006-02-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Refactoring to dissociate Gate completely from the servlet api

2006-02-12  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Incredibly stupid classloader bugfix. The context classloader was only set
  in the init() method of the RIFE servlet/filter, but not in the service and
  destroy methods.

2006-02-10  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed bug where arrival elements didn't properly rewrite reflective
  datalinks and flowlinks

2006-02-09  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Made the type of the template property not mandatory anymore and defaulted
  it to enginehtml

2006-02-08  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for flowlink-specific datalinks

2006-02-07  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added test for raw content storage of byte arrays

2006-02-06  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Additional tests for embedded element support in OOC testing framework

  * Added tests for embedded response support in out-of-container testing
  framework

  * Added tests for embedded element priorities

  * Updated copyright year

  * Made error reporting templates xhtml compliant and use css for formatting.

  * Adapted the formatting to correctly display template syntax errors in a
  pre formatted style.

  * Made getEmbeddedResponse a bit more user friendly

  * Implemented embedded element priorities.

  * Added support for embedded element retrieval in MockResponse.

2006-02-04  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added RAW content store support for byte[] as well as InputStream.

2006-02-03  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added getResourceFinder() to Site

  * Changed order of automatic value replacement in processTemplate to make it
  possible to use data elements in form building values

  * Fixed bug where the active element threadlocal is not cleared after an
  exception and thus template property injection creates a stack overflow
  exception.

  * Bugfix related to element property injection that only has to kick in after
  a valid ElementContext

  * Added isEmbedded method to ElementSupport

  * Minor bugfix related to embedded element inside templates that are
  instantiated through property injection.

  * Minor bugfix wrt to the order of the validation with a ValidationContect
  and Callbacks.

  * Fixed callbacks NPE with Derby

2006-02-02  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added Tyler's mail queue ssl + auth support. Had to re-enable the old way
  of sending the messages without auth, otherwise the socket connection would
  just stay open and never close in the local test. The ssl and auth should be
  tested again.

  * Added blankValue() to Template

2006-02-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added warning to the log to indicate when auto compilation is not
  supported.

  * Made servlet containers that return null for
  ServletContext.getRealPath("/") not support auto compilation.

  * Removed TemplateClassLoaderClasspath since Templates have been generated
  directly to bytecode since quite a while.

2006-01-31  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed RetroWeaver JDK 1.4 issue.

  * Renamed alias to catalog in the XML entity resolver. Still need to find an
  acceptable way to setup current and old versions of the DTD catalog, probably
  by including the rife_catalog.xml file, parsing it and including all the DTDs
  of the older versions.

  * Trial to support ClassPath for XML entity resolving.

2006-01-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Set EOL property to LF

2006-01-26  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RIFE-265: Add a method for width/height/ratio of a scaled image to be
  forced via CmfProperty. The behavior of the CMF content attributes has
  changed. If both width and height are specified, they'll indicate a maximum
  bounding box and the image will be rescaled by preserving its aspect to fit
  the bounding box as closely as possible.

  * Changed template unittests to use to embedded derby instead

2006-01-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed performance issue with UniqueIDGenerator

  * Upgraded ASM 2.2.1.
  
  * Updated continuations engine for new ASM behaviour.

2006-01-20  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Classloader fixed for integration with other libraries and filters that are
  loaded through web.xml

2006-01-17  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor bugfix to ensure that identified elements continue to prolongue the
  authentication session.

2005-12-31  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Upgraded HttpUnit to 1.6.0

2005-12-30  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for setting reflexive outputs and globalvars accross
  submissions.

2005-12-29  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed GQM install(CreateTable) methods for derby and mysql driver support

2005-12-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Removed dependancy on Sun's JDK in the HTTP tool classes.

2005-12-23  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 1.3.1

2005-12-22  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Workaround to force JDK 1.4 on Windows to correctly interpret
  file://C:/location URL specs.

2005-12-20  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for Derby network client JDBC driver+

  * RIFE-259 : clearOutput pathinfo input doesn't clear the output
  This bug only appeared for flowlinks that targeted their originating element

2005-12-19  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fix to content syndication framework where the Entry ID property didn't
  have the appropriate meaning.

2005-12-18  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed auto-templating bug+

2005-12-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added getInputSerialized method to ElementSupport.

2005-12-09  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor build file fix

2005-12-09  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 1.3

2005-12-08  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor fixes to the validation error marking, in case the same submission
  bean is used in different submissions of the same element

  * Removed duplicate code in ClassUtils

2005-12-07  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RIFE-173 : Automatically redirect to URL with trailing slash when user
  visits "url.com/subsiteprefix"

2005-12-06  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RIFE-186 : Add new type of element input: "pathinfo input"

  * RIFE-247 : Allow getXhtmlTemplate() with no arguments to return template
  with same path as element path
  
  * Improved pathinfo mapping tests a bit

  * Added support for exit query pathinfo mapping

  * RIFE-235 : Remove dependency on CodeGuide to have a 1.4 compatible jar.
  Made one build file only that creates both 1.4 and 1.5 packages.

2005-12-05  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * First phase of adding pathinfo mapping support

2005-12-03  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Windows-related classpath introspection fixes

  * Added regexp encoding method StringUtils

  * Ensured that all the asm classes are loaded by the parent of the
  EngineClassLoader

2005-12-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated Netbeans project

  * RIFE-254 : RIFE should not ignore exception thrown by
  XMLReadereFactory.createXMLReader()

  * Made 1.5 build files the defaults

2005-11-29  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for JNDI datasources in the datasource XML declaration

  * Added better support for javax.sql.DataSource, with auto-detection of
  supported JDBC driver names

2005-11-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor fix to TemplateFactory

  * RIFE-251 : Default implementation of pause() should throw exception, not do
  nothing. Also added this for call()

2005-11-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RIFE-241 : Make exits and outputs optional. This has been implemented for
  in-lined element declarations.

2005-11-25  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated HsqlDB

  * Updated Derby and Spring

  * Updated Groovy, ImageJ, Imageroreader, Janino, Pnuts and Rhino

2005-11-23  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RIFE-234 : Feeds should be able to add custom XML namespaces

  * Fixed dbcentric ant task

2005-11-21  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RIFE-240 : Add support for UUID Java Datatype to CreateTable Functionality.
  Added support for it to the complete DB abstraction layer too.

  * RIFE-246 : Improve error message for table-less Update. Improved error
  reporting for all other query inconsistencies.

  * Added support for byte[] property types to the GenericQueryManager.

2005-11-16  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added getPropertyTyped methods and changed authentication elements to use
  these instead of casting.

2005-11-14  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RIFE-228 : Mailqueue should provide better feedback in presence of incorrect
  datasource option

  * Added name attribute to project files

  * Made the build file work on Windows

  * RIFE-223 : Allow including XHTML from HTML template

2005-11-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RIFE-212 : Elements should set their Content-Type header based on the engine
  of the template printed

2005-11-11  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for other fixed request methods, and also for any possible
  other request methods

2005-11-09  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed the Spring participant to support a config location parameter as the
  parameter of the participant.

2005-11-06  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor 1.5 related fix

  * Added support for dynamic embedded element differentiators.

2005-11-05  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Committed eclipse setup

2005-11-04  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for javax.sql.DataSource to com.uwyn.rife.database.Datasource

2005-11-03  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * More fixes to the EngineClassLoader to behave correctly in a situation of
  hotswap and auto-compiled classes.

  * Javadoc fixes

  * Added beforeValidate and afterValidate callback methods.

2005-10-28  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Testing framework fixes

2005-10-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor memory usage improvements to the engineclassloader

2005-10-25  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Another classloader fix, all known Linkage exceptions are now fixed.

2005-10-22  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixes for Firebird DB

  * Fixes for bad memory usage while streaming large content from the CMF with
  PostgreSQL

2005-10-21  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fix for db connection not being closed in the case of an out of memory error

2005-10-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 1.2

  * Renamed the 'rife.engineclassloader.enabled' init param to
  'engineclassloader.enabled'

2005-10-14  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added method to obtain a Site's resource modification times.

  * Request attributes fix in test API.

  * Added support for 'rife.engineclassloader.enabled' servlet and filter init
  param to enable / disable the engine classloader.
  
  * Experimental change to EngineClassLoader to better isolate classloader
  hierarchies, this could break things.

2005-10-09  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RIFE-231 : Automatic compilation of Java element implementations is broken

2005-10-06  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Source cleanups according to Eclipse code inspections.

2005-09-30  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for declaring everything in a subsite declaration that you can
  in a site specification.

2005-09-28  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added getStatus method to MockResponse.

  * Added static convenience method to ParsedHtml for obtaining the value of a
  node's attribute

2005-09-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RIFE-230 : Add to the testing framework the ability to evaluate an xpath
  expression based on a context node

  * Added validateAsXml() to MockResponse.

  * Changed MockResponse xpath methods to strip away the HTML root element
  default namespace

2005-09-26  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Regression fix to the ElementInfo cloning with regards to properties.

2005-09-23  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 1.1

  * Added dual license for CDDL

2005-09-22  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Site builder API improvements

  * Added easy xpath evaluations to MockResponse

2005-09-21  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Bugfix to RunWithEngineClassLoader

  * Minor fix to properly support config properties in the rep.

  * Javadocs fixes

  * Removed all property name conflict checks.

  * Reimplemented the engine IoC property hierarchy.

  * Fixed a regression bug in the exit url generation.

2005-09-20  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for getProperty(String name, Object defaultValue) in
  ElementSupport

  * RIFE-226 : Allow generation of EXIT:QUERY links to url-less embedded
  elements

2005-09-19  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Refactored IoC property support into a separate package.

  * Implemented RIFE-221 : Support IoC for the repository and its participants

2005-09-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Applied jboyens' patch for making the selected date clickable in
  JDateSelector

2005-09-14  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RIFE-224 : Template engine exceptions should give context information:
  filename, line, colum

  * RIFE-217 : AttributeNotEndedException should give context information like
  line/column number

  * Site DTD update

2005-09-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RIFE-218 : Submissions do not allow unlimited number of file uploads

  * RIFE-88 : Write unittests for rep participant cleanup

  * RIFE-62 : Write detailed unittests for authentication cookie handling

  * RIFE-196 : Add RoleUserAttributes.removeRole

2005-09-12  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Finished the testing framework javadocs.

  * Project file updates for the new EngineClassLoader main wrapper.

  * Testing framework refactorings.

  * Added RunWithEngineClassloader class.

  * Added javadocs for classes and interfaces that have been added to the
  engine package for the implementation of the testing framework.

  * Minor API fixes.

2005-09-11  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Source cleanups

  * Added methods to MockResponse to obtain the target element, target element
  info and target element id.

  * Added parameters extraction methods to MockLink.

  * Added support for session state storage in test framework.

2005-09-10  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for file uploads in out of container testing.

  * Added some OOT tests

  * Added some form api methods.

  * Added support for browser-central cookies that are persisted across request.

  * Added support for select boxes selected options to response form parsing.

  * Further OOT improvements

2005-09-09  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Initial working version of out-of-container tests.

  * Gate, Request and Response refactoring to make it possible to add support
  for out-of-container testing.

2005-09-02  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed RIFE-219 : Strange error message when instantiating
  GenericQueryManager when bean has identifier(true) property which is not
  called "id" and does not have no-arg constructor

2005-08-30  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 1.0
  
  * Added fallback icon resolving for swing dialogs if the Images participant
  isn't there.

2005-08-25  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Upgraded XFire to the official 1.0-M5 release

  * All standard RIFE elements that use a datasource property now don't expect
  a datasource name anymore, but an actual Datasource instance through IoC.
  This is an easy fix, just surround the datasource name with the <datasource>
  tag.

  * Added getExceptionStackTraceMessages utility method to ExceptionUtils

  * Minor fix to ValidationBuilder to properly distinguish the fallback from the
  wildcard ERRORS block.

2005-08-25  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor fix to form building.
	
  * Regression fix to template engine.
	
  * Feed api consistancy improvement.

  * Added JavaMail docs as an javadoc external url.

2005-08-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Finished planned javadocs for 1.0 release

2005-08-23  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Additional database javadocs

2005-08-22  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadoc updates

2005-08-21  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for the display of invalid formatter string with a good
  programming design.

2005-08-20  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Source code refactorings that extract common functionalities to BeanUtils.

  * Added support for the format constraint and a default input date format for
  bean properties with the java.util.Date type

2005-08-19  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Finished engine package javadocs

  * Renamed the "identity" request attribute to prevent name clashes. It now
  follows the recommenda tions of the servlet spec. The new name is
  "com.uwyn.rife.authentication.credentialsmanagers.RoleUserIdentity", but it's
  best accessed through the Identified.IDENTITY_ATTRIBUTE_NAME static variable.

  * Minor email validity checking update

2005-08-18  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadoc updates
  
2005-08-17  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadoc updates.

  * Upgraded groovy to final 1.0-jsr-03 release.

2005-08-16  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadoc updates.

2005-08-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added SessionValidatorRetriever utility class.

2005-08-14  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadoc updates.

2005-08-07  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for SERVER:ROOTURL

  * Minor javadocs fixes.

2005-08-06  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadoc updates.

2005-08-05  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadoc updates.
  
  * Minor example changes

2005-08-04  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated derby.

  * Fixed idea and eclipse projects.

  * Javadoc updates.

2005-08-04  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadoc updates.

2005-08-03  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadoc updates.

2005-08-02  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixes for latest xfire snapshot

  * Fixed AbstractCallbacks API skew.
  
2005-08-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added some javadocs.

2005-07-31  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added some javadocs and stubs to ElementSupport.
  
  * Also some consistancy API changes.

2005-07-29  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added source code highlighting for the new example.

  * Added advanced continuations example

  * Removed some environmental variables that have no more use.

  * Regression compilation fixes with 1.5 due to Eclipse faulty support for
  generics and code inspections.

  * Added oracle jdbc jar to source repository with license document. It will
  not be shipped with any binary distribution.

  * Added all remaining package javadocs.

2005-07-28  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added some package javadocs.

2005-07-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Removed all dao packages since we put managers in the dam packages.

  * Added a bunch of package javadocs

2005-07-25  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added ManyToOne information.

  * Updated Groovy to the latest JSR-03 snapshot jar.

  * Added hack to not use Groovy's metaClass property in the BeanUtils methods.
  
  * Rearranged Mail testsuite to make it run properly.

  * Regression fixes to make it compilable with cgjavac

  * Large amount of source code inspection fixes.

2005-07-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Refactored the location of database type conversion drivers.
  
  * Started adding package-level javadocs.

  * Javadocs packaging update.

2005-07-22  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor fixes for javadocs.

2005-07-19  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated build file for feed integration.

2005-07-16  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed issue RIFE-182 : Add SelectResourceBundle class for use in templates.

2005-07-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Integrated RIFE/feed.

2005-07-14  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added property retrieval support to site builder beside only storage.

2005-07-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixes to paged navigation builder.
  
  * Fixes to property propagation through subsites.
  
2005-07-12  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Made the order of all site declaration artifacts predictable.

  * Added check to template parser to detect value tags that are closed when
  they aren't open yet.

2005-07-11  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fix to sitebuilder resource modification time storage to ensure that the
  auto reload config parameters is always respected even if a site processor
  doesn't.

  * Added Callbacks javadocs

2005-07-10  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added callbacks support to the GenericQueryManager, still needs javadocs.

2005-07-08  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Refactoring to have dedicated exceptions in the site and element builders
  instead of the remnants from the XML-only approach from before.

  * Finished XFire integration and all related tests. Also supports the
  ElementService interface, just like Hessian.

2005-07-07  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Removed support for Axis.
  
  * Added basic support for XFire, some other features are still needed for it
  to be finished.

  * Minor engine classloading fix for better jdk 1.4 support.

  * Upgraded hsqldb to v1.8.0 and updated the support for the changed features.

  * Updated mysql jdbc driver

  * Upgraded pnuts

  * Upgraded postgres jdbc driver to v8.0-311 and made some fixes to correctly
  support it.

2005-07-06  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Engine continuations instrumentation bugfix.

  * Minor bugfixes.
  
  * Added Integer support for GQM identity properties.
  
  * Added support for specifying global bean, input beans, output beans and
  submission beans with a class instead of only a classname.

2005-07-05  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Removed support for JRuby.

  * Minor template unescape optimization.

  * Updated bsh, dumbster, imageroreader and spring

2005-07-04  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed issue 179 : Be more forgiving about whitespace in template directives.

  * Minor NPE bugfix in template bean handler.

2005-06-29  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * JDK 5.0 compilation fix.

  * Minor fix to DatabaseMailQueueExecutor mail queue name.

  * Upgraded derby to v10.0.2.2

  * Upgraded groovy to v1.0-jsr-02.

  * Upgraded janino to v2.3.4.

  * Upgraded hession to v3.0.13.

2005-06-29  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Finished unittests of site declaration of bean validation groups.
  
  * Added fillSubmissionBean tests.

2005-06-28  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Further added bean group support in site declaration and added unittests.
  
2005-06-26  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Started adding tests for site structure bean declarations with group
  specification.

2005-06-25  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added the following config parameters: RESPONSE_REQUIRES_SITE,
  SITE_INITIALIZING_REDIRECT_URL, SITE_INITIALIZING_PASSTHROUGH_SUFFIXES and
  implemented the related functionalities.
  RESPONSE_REQUIRES_SITE is true by default, and when it's false the site
  initializes in the background, responding with a 503 status code.
  Instead of this, all requests can be redirected to a single URL by setting
  the SITE_INITIALIZING_REDIRECT_URL config parameters.

2005-06-22  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Mail queue fix to reliably keep messages that couldn't be sent due to an
  SMTP server failure.

  * Made automatic CmfProperty name population from uploaded file names more
  intelligent to only do it when no name has been specified already, and by
  making sure that the maxlength of 100 chars is never exceeded.

2005-06-20  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Changed the API for getContentForHtml in the CMF so that it uses an active
  element that is able to take the gate url into account

  * Added Validation group support to bean specifications in the engine
  declaration.

2005-06-17  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added javadocs and tests for queueing of full-blow javamail messages.
  
  * Implemented a LightweightEngineException class that doesn't gather the
  stracktrace at instantiated. Made all runtime 'jump' exceptions for exits,
  childtriggers, deferring, forwarding, redirecting, continuations use that
  lightweight class for performance improvements.

2005-06-16  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for configuring hostip restriction on authentication sessions,
  it is now disabled by default. The config parameter SESSION_RESTRICT_HOSTIP
  can be used to change the behavior.
  
  * fillSubmissionBean fixes to correct reset not submitted parameters to the
  default values (ie. unchecked checkboxes).

2005-06-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for queuing complete JavaMail MimeMessage objects in the mail
  queue.

2005-06-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor bugfix for HttpUtils.
  
  * Bugfix for displaying raw CMF property content through bean handler classes.

2005-06-07  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fix to make circular subsite detection not look at manual subsite processors

2005-06-04  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added checks to make sure that the pathinfo is only auto-added to submission
  URLs when the element actually supports pathinfo. This could happen when a
  pathinfo element exited to a none pathinfo element with a submission.

2005-06-02  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Made element ids and urls have a predictable order in the site structure.

2005-05-31  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for multiple unnamed participants of the same class.

2005-05-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Source code compatibility fixes.
  
  * NPE fix to MemoryUsers.

2005-05-26  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Localization resourcebundle lookup optimization to prevent going through all
  the candidates all the time.

2005-05-25  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Performance optimization that detects Sun's proprietary classes and uses
  those when possible to optimize the loading of class bytes.

  * Template (and thus SQL query builder) startup performance improvement in
  development configuration.

  * Startup performance improvement for site startup in a development
  configuration.

  * Profiling of startup time and 15% speedup.

2005-05-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed utterly stupid mail queue bug

2005-05-23  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added bbcode img alt attribute

2005-05-21  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 1.0rc2
  
  * Added support for ValueRenderer and
  <!--V 'RENDER:classname:differentiator'/--> tags

2005-05-20  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added the other http request methods to the RequestMethod enum class.

2005-05-19  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added [pre] support to bbcode parser.
  
  * Javadocs fixes.
  
  * Compilation fix for cgjavac.
  
  * Upgraded ASM to the stable version 2.0 release.
  
  * Correctly implemented property hierarchies and scopes with sites, subsites,
  elements and element declarations. Site declarations now support properties
  too.
  
  * The SiteBuilder's API changed with an additional
  enterSubsiteDeclaration(String declarationName) method before the
  enterSubsite() method.

2005-05-17  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added optional name to mail queue task that will be shown in the logging.

2005-05-16  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed RIFE-214 : Pathinfo of the embedding element should be added to the
  URL of embedded submission urls.
  
  * Localization resourcebundle cache improvement.

2005-05-09  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added jardbcentric ant task and an optional dbdriver property.

2005-05-08  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Made localization resourcebundles redeployable even when they are not
  reloadable. Made the lookup of resourcebundles follow exactly the same
  semantics of the JDK ResourceBundle class.

2005-05-05  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added missing startWhere() support.

2005-05-04  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added startWhere() and end() support to query builders.

2005-05-02  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Integrated jboyens' bbcode [code] patch.

2005-05-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for submission regexp parameters to getSubmissionBean and
  fillSubmissionBean.

2005-04-28  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * CMF bugfix where text content was served with missing bytes when non
  iso-8859-1 chars were used.

2005-04-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Typo fixes.
  
  * Integrated jboyens' patch for sparse constraint and GQM support.
  
  * Allow IPV6 to be used with the session manager as the hostIp (40 chars).

2005-04-26  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Small bugfix where contenttype was overwritten by an extended element, even
  if it wasn't specified.

2005-04-26  JR Boyens  <jboyens[remove] at uwyn dot com>

  * Added extra javadoc for GenericQueryManager.save(BeanType) outlining
  identifier behavior.

2005-04-25  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Integrated jboyens' GQM patch and fixed a minor thing.

2005-04-25  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added RIFE XD solution file.

2005-04-23  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated source code highlighting.

2005-04-22  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Regenerated highlighted source with JHighlight.

2005-04-21  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Made RIFE-applications re-deployable. This wasn't possible before, since our
  resource loaders and class loaders relied on URL.openStream() which by default
  caches all content. We now disabled all the caches.

2005-04-20  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Made the memory scheduler cleanup at servlet teardown.
  
  * Example updates.

2005-04-19  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixes to input and parameter injection

  * Minor source updates.

  * Minor example updates.

2005-04-18  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Don't throw an exception when the conversion fails during the injection of
  inputs and parameters.
  
  * Build file updates.

  * Added ant target to create a JDK 5.0 noweb RIFE jar.

  * Some work to make RIFE usable without the web engine.
  
2005-04-17  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Adapted numberguess examples to show the use of input and parameter
  injection.
  
  * Added support for "element" expression var in engine template types.
  
  * Added submission parameters injection.

2005-04-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added IoC inputs injection.

2005-04-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fix to blocking participant that didn't properly wait for participant
  initialization when getObject() is used.

2005-04-11  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added a flag to HttpUtils retrieve method to not actually download the
  content of a page

2005-04-10  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Finished IoC support.
  
  * Upgraded Janino and Pnuts.
  
  * Fixed a CMF unittest on MacOSX.
  
  * Finished Convert class and tests for use in IoC injection.

2005-04-09  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for untrusted SSL certificates to HttpUtils

  * Work on the Convert class for use in IoC injection

2005-04-07  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Finished IoC property value reference retrieval and the XML declaration.

  * First step of IoC support

2005-04-06  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed bad constructor.

  * Upgraded groovy to version 1.0-jsr-01

  * Made RIFE GUI prototype start up fast again.

2005-04-05  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed RIFE-209 : embedded elements should be able to cancel the embedding
  context when exiting.
  
  * Updated config and datasource participants to correctly respond to
  getObject(key) method calls.

2005-04-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Optimizations to OrdinalManager's tighten method

2005-03-31  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added accessor type specification in the BeanUtils.

2005-03-30  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for Rep context.

2005-03-29  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for Oracle 10g join statements in Select queries
  
2005-03-16  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 1.0rc1
  
  * Updated XML files prolog to reflect the correct encoding

  * Updated and restructured the examples to show some of the new features

2005-03-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Made some of the elementinfo methods public

  * Added incookie value setting in engine templates.

  * Also added a number of convenience methods to work with incookie
  collections.

  * Made the logout elements auto-detect which authvar type to clear.

2005-03-14  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Reset the RequestState target elementinfo to the current element after a
  call continuation answer, since otherwise it still points to the call exit
  element and generates wrong submission context IDs.

  * Added CommittingRuntimeException marker interface to make it possible to
  have 'positive runtime exceptions' inside transaction code.

2005-03-11  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed bug where useConnection and inTransaction didn't work well together.

2005-03-10  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Applied JR's stringutils patch

2005-03-09  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed RIFE-199 : RIFE creates invalid authrolelink rows sometimes

  * Fixed RIFE-200 : Change CredentialsManagerException to extend
  RuntimeException

  * Fixed RIFE-198 : RoleUsersManager.getAttributes should never return a
  RoleUserAttributes with a null roles list

  * Fixed RIFE-197 : DB-backed authentication needs to provide better
  diagnostic information when DB connection fails

2005-03-05  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added CreateTable.ViolationAction support to manyToOne constraint.

2005-03-03  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Removed table alias support for the ContentQueryManager, but added a
  backend reference class instead which will also be used to construct the
  paths that refer to the content. This should later be refactored into a
  feature of ConstrainedBean to allow specification of bean/table aliases in a
  central location.

2005-03-03  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixes to correctly generate links to elements that are mapped to /*

2005-03-02  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Upgraded Rhino and reimplemented its integration to embed it directly
  instead of using BSF

  * Upgraded ImageJ, ImageroReader, MySQL JDBC, PostgreSQL JDBC

  * Committed JR's paged navig pathinfo addition

  * Upgraded pnuts and hessian.

  * Updated Groovy and Janino

2005-02-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added some convenience Select query statements.

2005-02-26  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added 'unformatted' content attribute that makes the content stores not
  format or transform content that is stored.

2005-02-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Changed ordinal manager to work with longs instead of only ints as
  restriction ids.

  * Ignore ContrainedBean uniqueness validation checks when one property is null

2005-02-23  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed RIFE-180 : Multiple calls to addConstraint on validation-aware bean
  for given property replace old constraints instead of adding constraints

2005-02-22  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Removed accept-charset from the submission:form tag result since all
  browsers seem to use UTF-8 correctly if it's set as the response's charset.

  * Fixed RIFE-177 : RIFE should be flexible about templates without
  MARK:ERROR

  * Added a call/answer unittests to verify that datalinks work and not just
  global vars.

  * Thread safety fixes.

2005-02-21  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added whirlpool encryption support to StringEncryptor

  * Added mail queue javadocs

  * Added support for Firebird and DaffodilDB in the mail queue

2005-02-20  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Testsuite regression fixes.

2005-02-19  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Integrated mail queue, still needs javadocs

2005-02-16  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for PROXY_ROOTURL

2005-02-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Put element initialization back into full context, after submission
  context extraction

  * Removed ClassUtils.inherits, using Class.isAssignableFrom instead now

  * Regression fix where processEmbeddedElements got removed accidently

2005-02-14  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added getEmbeddingTemplate() to ElementSupport

2005-02-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed numeric overflow

  * Enforced "/" between successive subsite prefixes

2005-02-11  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Upgraded DaffodilDB to v4.0
  
  * Added XML FormBuilder, ValidationBuilder and BeanHandler

2005-02-09  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added LOG_ENGINE_EXCEPTIONS config var which is default and will always
  log with the mention of the server name and port

  * Config updates.
  
  * Updated handling of exception in gate to include the server info for
  identification

2005-02-08  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Bugfix for subsite url slash seperation

2005-02-03  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Regression bugfix regarding arrivals to url-less elements that are part of
  subsites without url prefix.

2005-02-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Implemented RIFE-176 : Value specified by defaultValue is not shown in
  SELECT form box when that value is not in the inList collection

  * Fixed RIFE-174 : Add "notBlank" constraint
  Implemented by adding trimming to the notEmpty constraint.

  * Fixed RIFE-175 : Implement manyToOne constraint for form validation

2005-01-31  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Made template config value tag replacement early, and l10n value tag
  replacement both early and late.

  * Added support for resourbundle class names as template default resource
  bundles.

  * RIFE-168: Provide official DTD URL's to allow for PUBLIC part of XML
  DOCTYPE

  * Fixed RIFE-171 : Allow arrival to point to element with no url attribute

  * Added support for element declaration inside site XML file.

  * Scheduler bugfix to allow the reuse of the same executor with different
  tasks.

2005-01-30  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed pathinfo support for arrival elements

  * Correct handling of empty pathinfo in url building

  * Consistency fix in the OrdinalManager update methods to not rollback a
  transaction, but return false instead.

2005-01-28  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added default empty processElement method in Element class. This is handy
  for elements that only handle submissions.

  * Fixed RIFE-170 : Behavior when using wildcards is confusing

  * Fixed RIFE-169 : Provide more useful error information when
  requesting templates with common errors
  Slashes are now replaced by dots, the factory's extension is removed from
  the name if it's found and the special case ext.ext is reported as
  ambiguous.

2005-01-25  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor consistency bugfix to OrdinalManager.

2005-01-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for getRestoreQuery(id) and getDeleteQuery(id)

  * Added missing RestoreQuery delegate method.

  * Added support to the OrdinalManager to easily move an ordinal to an
  arbitrary location, useful for drag & drop stuff.

2005-01-20  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Formbuilder regression bugfix related to FORM:NAME and FORM:VALUE in
  custom collection fields

2005-01-18  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added getServletContext() to ElementSupport

2005-01-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Bugfix for submission inputs preservation over inheritance.

2005-01-07  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for configuration values in memory scheduler task option
  definitions.

2005-01-05  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 0.8.2

  * Updated examples index page
 
  * Minor fixes for running all database tests.

  * Added X-Develop project files.

  * Workaround for 5.0 compiler bugs.
 
  * Javadocs fixes.

  * Copyright year updates

  * Removed contrained bean constructors in query builders that don't support
  them (ie. one Select has one now)
  
2005-01-03  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added constructor parameter to DB query builders that makes the builders
  aware of constrained beans so that they can adapt to ConstrainedBean
  constraints. Currently, this only has an impact in Select queries for the
  defaultOrdering constraint.

  * Added support for ValidationContext interfaces.
  Implemented a ValidationContext on top of the generic query manager to
  check for uniqueness constraints before storing any data.

2005-01-02  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for resetGroup to Validation

  * Regression bugfix to correctly handle array type properties that are set
  through output beans (ie. not serialize them but handle them with multiple
  parameters instead)

2005-01-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Made fillSubmissionBean correctly set properties to the empty value if
  an empty parameter has been submitted.

  * Updated copyright year

  * Made the PrintTemplate element extensible

  * Bugfix to make site properties propagate to sub-sites

  * API updates for more flexible site structure introspection

2004-12-30  Geert Bevin  (gbevin[remove] at uwyn dot com)

   * Added support for automatic preservation of serializable bean properties
   through outputs / inputs / exits. Need to evaluate how to integrate a
   similar feature with form building.

   * Added detection of URL length overflow with logged warning and automated
   fallback to session state storage.

2004-12-29  Geert Bevin  (gbevin[remove] at uwyn dot com)

   * Implemented RIFE-159 : Implement database capabilities and compensators

2004-12-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

   * Reduced memory using for queries by dynamically putting parameters in a
   HashMap.

   * Preparing implementation of parametrized constraints.

2004-12-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

   * Javadocs additions and code cleanups.

   * Fix to forward to outsides URLs, some headers are now filtered out.

2004-12-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

   * Implemented a reliable way to pass along internationalized text along
   the query string.

   * Defaulted URL encoding to UTF-8 since all encoding defaults in the
   engine use UTF-8 now.

2004-12-23  Geert Bevin  (gbevin[remove] at uwyn dot com)

   * Added correct handling of internationalized parameters.
   
   * Every character encoding now defaults to UTF-8 and this is also used in
   the form building.
   
   * Added support for GQM with another name than the bean name.

   * Workaround for JDK 5.0 compiler bugs.

   * Moved the ValidationError collection to a Set instead of a List to
   ensure that duplicate errors are not listed.

2004-12-22  Geert Bevin  (gbevin[remove] at uwyn dot com)

   * Added support for ConstrainedBean uniques and defaultOrder to the
   database query builders.

   * Upgraded One$DB/DaffodilDB to 3.4.1.

2004-12-21  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Integrated ConstrainedBean in the Constrained interface

  * Added ConstrainedBean tests.

  * Source cleanups.

2004-12-20  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated Groovy to 1.0 beta8

  * Added more ConstrainedBean features

2004-12-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Some fixes to be nicer on the garbage collector and reduce memory usage.

2004-12-11  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor NPE fix

  * Updated debug output a bit

2004-12-10  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Bugfix to fix the fact that element were always checked for auto-reload
  even when the config parameter was set to false.

  * StringUtils.encodeUrl enhancement to reduce memory usage.
  
  * Minor code cleanup in the EngineClassloader to reduce memory usage.

  * Upgraded derby to v10.0.2.1

  * Started the ConstrainedBean implementation.

  * Build file updates.

2004-12-09  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added full support for One$DB/DaffodilDB

2004-12-08  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added further support for DaffodilDB

  * Upgraded to hsqldb 1.7.3

2004-12-07  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for 'local' and 'global' submission scope attribute.

  * Added support for FORM:DISPLAY tags that will display the value of bean
  parameter, taking lists and labels into account. This was needed to make it
  possible to easily build confirmation steps after the actual data entry.

2004-12-04  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added consistancy check when elements are added without implementations
  or wrong declarations (ie. forgetting .xml for xml element declarations).

2004-12-03  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Merged submission context and submission target.

  * Added base64 encoding for their values.

  * Fixed a minor bug related to precedence.

  * Implemented RIFE-161 : Submissions of embedded elements should only
  arrive at the element that generated the form

2004-12-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Initial implementation of submission target id.

2004-11-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Stupid contraint regression bugfix.

2004-11-26  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated configuration and build file for Netbeans 4RC1

2004-11-25  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated ant build files to not check for cloudscape anymore since derby
  is now included.

  * Workaround for Orion's weird classloader resource protocol.

  * Upgraded to ASM 2.0 CVS to fix 5.0 debug info problems

  * Implemented RIFE-160 : Reimplement ConstrainedProperty and CmfProperty

2004-11-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Redesigned ConstrainedProperty internally to reduce memory usage.

  * Fixed another continuations bug related to different control flow
  generated by javac of jdk 5.0

  * Fixed continuations bug related to different control flow generated by
  javac of jdk 5.0

  * Upgraded ASM to v2.0alpha

2004-11-23  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Upgraded ASM to v1.5.2

  * Added support for One$Db/DaffodilDb to the core database engine, still
  needs to port to other sub-frameworks.

2004-11-22  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added a java to sql type mapping for byte[]

  * Refactored cloudscape to derby

  * Removed support for Cloudscape 5.1 and ported the drivers to
  Cloudscape 10 / Derby

2004-11-19  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for subsite properties.

  * Fixed bug that made WhereGroups wrongly return their parent query when
  end() is called.

  * Solved issue RIFE-163: When Rife sees a request for "x", it should check
  to see if a site has a prefix "x/"

2004-11-08  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Implemented initial limit/offset capabilities compensator for McKoi.
  Parametrized limits and offsets aren't supported yet.

  * Regression bugfix in where parameters.

  * Initial implementation of db capabilities compensators

  * Bugfix to not use alpha transparent images with jpeg formats

2004-11-02  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * ImageFormatter fix to handle transparent images.

2004-10-29  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for embedded element differentiators.

2004-10-29  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Bugfix to make the XHtml template bean handler play nice with non XHtml
  CMF text content.

2004-10-25  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Bare URL StringUtils patch.

2004-10-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed long-standing thread conurrancy bug related to named prepared
  statement parameters.

2004-10-23  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Removed certain methods from DbQueryManager that stand in its way to
  become a true DB abstraction layer.

2004-10-21  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * The ContentQueryManager now only refrains from storing null content on
  properties that are not set to autoRetrieved.

2004-10-20  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Applied JR's bare StringUtils patch.

2004-10-19  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added WhereGroup support to GQM DeleteQuery, RestoreQuery and CountQuery
  
  * Fixed 5.0 compilation error.
 
2004-10-18  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for ResourceFinderGroup

2004-10-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Ensured that fetchSize is 1 for executeGetFirst* DbQueryManager methods.

2004-10-12  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * L10N and dateformat fix.

2004-10-11  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Integrated jboyens' BBcode improvements to StringUtils.

2004-10-08  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor template factory fix.

2004-10-05  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Made some managers cloneable.

2004-10-04  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Changed GenericQueryManagerDelegate, OrdinalManager and
  ContentQueryManager to not extend DbQueryManager, but use composition
  instead. Otherwise the DbQueryManager get publically exposed and that's
  confusing.

  * Updated groovy.

2004-10-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor GQM fix to make RestoreQuery and CountQuery implement ReadQuery
  instead of Query.

  * L10N fix for J2SE 5.0

2004-09-30  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Dirty hack around an IE bug that incorrectly handles anchors in redirect
  headers.

2004-09-28  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 0.8.1
  
  * Fixed authentication bug, where the acceptedCredentials hook was not
  correctly called for RoleUsers

  * Added processTemplate(Template) to ElementSupport which does the same as
  print(Template), except that the content isn't printed to the request.
  Minor template API fixes.
  
  * RELEASE 0.8.0
  
  * Authentication example fix.

2004-09-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added one more header to preventCaching method to ensure that the page
  is never stored.

  * Added support for automatically reloaded resource bundles and a
  L10N_RESOURCEBUNDLE_AUTO_RELOAD config param to activate/disable it. The
  default is true.

2004-09-25  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added some more CMF unittests.

2004-09-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added better support for repository to ContentQueryManager and
  CmfProperty.

  * Regression unittests bugfixes.

  * Build file fix to correctly run the tests through ant.

2004-09-23  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for submission bean retrieval without providing the
  submission name.

  * Javadocs update.

  * Added support for several submissions in one request.

2004-09-22  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadocs and build file fixes.

  * Minor fix to standalone use of StringEncryptor.

2004-09-21  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated CMF error message reporting to ensure that duplicate errors are
  only reported once.

  * Added nicer invalid xhtml error reporting.

  * Added better integration to obtain the loading errors of for example
  invalid xhtml.

2004-09-20  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added raw content stream close check.

  * Minor bugfix to allow a global pathinfo element to be used.

2004-09-18  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added some commented properties to make the element declarations clear.

  * Added missing file

2004-09-17  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added text/plain support to CMF.

  * Bugfix to correctly handle null values of boxed primitives in the bean
  fetcher.

  * Added support for co-existing regular url elements and pathinfo url
  elements at the same base location. Like this a fixed element can be
  used as the 'home' element for a certain url and all longer urls
  delegated to one that handles the pathinfo. This also allows for
  instance to create a CMS system that is overlaid by a fixed url
  structure.

2004-09-16  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * General firebird related fixes

  * Added support for configurable CMF table structure.

  * Added repository support to the ServeContent element.

  * Upgraded ImageroReader.

  * Added some CMF repository-related tests.
  
  * Added checking of the repository's existance before storing content.

  * Removed DB specific properties from ContentInfo and created the
  DatabaseContentInfo extending class specially for that. This that
  the contentId property doesn't bubble up until the top api.

  * Added initial support for repositories.

2004-09-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * CMF fixes.

2004-09-14  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Renamed CMF 'contentDataProperties' to 'properties'.
  
  * Added facility methods for working with properties.
  
  * Conceptually bumped up properties so that they are intended to be provided
   manually to store meta data about stored content.

  * Upgraded janino.
  
  * Added janino support as filtered tag processor.

  * Added support for content data properties and integrated it with
  getContentForHtml

2004-09-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added some CMF unittests.

  * Removed hackish code stripping for javadoc generation since instead of
  using the jsr-014 pre-release, we now use j2se 5.0 for javadoc generation;
  which works without any problems.

  * Worked a bit more on DaffodilDB support, but the DB still has too many
   probs to be supported yet.

2004-09-11  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Concurrancy bugfixes and speedups for the engine and the template
  classloaders.

  * Added CMF servecontent hook to allow paths to be filtered when they are
  served.

  * Fixed CMF bug where multi versions of content weren't deleted correctly.

  * CMF raw storage optimization by using as much streams as possible

2004-09-10  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Trapped IOException in CMF that happens when a client disconnects during
  serving of content.

  * Rearranged the Authentication element to correctly handle authentication
  templates that embed authenticated elements. Before this resulted in a
  stack overflow of method calls.

  * Correctly integrated ordinal support in the ContentQueryManager's delete
  method.

2004-09-09  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added unittests for CMF delete features.

  * Updated idea project

  * Initial implementation of content deletion.

2004-09-08  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added content-disposition header when content has a name

  * Code cleanup

  * Added some utility methods.

  * Made validation error generation and marking generation correctly
  consider the validated bean subjects when clearing. This allows the
  usage of multiple beans on the same template.

  * CMF db structure fix

2004-09-07  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Permission fixes

  * Updated pnuts
  
  * NPE fix

2004-09-07  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for 'file' constraint.
  
  * Integrated CMF into the engine and added automatic handling of file
  uploads and bean properties.

2004-09-06  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Implemented RIFE-148 : It should be possible to group where query parts
  
  * Added support for getting content from the CMF through the combination of
  path and name.

  * Added support for name in contentinfo

2004-09-04  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added some more unittests.

  * Changed data used by useContentData for raw storage to InputStream instead
   of byte[]

  * Moved com.uwyn.rife.database.exceptions.InnerClassException to
  com.uwyn.rife.tools.InnerClassException

  * Added javadoc clarification for deepClone method.

  * Refactored CMF getContentData to useContentData

  * CMF oracle text storage fix

2004-09-03  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Additional CMF fixes and support for raw storage.

2004-09-02  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Further work on raw data storage in the CMF

2004-09-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added raw content storage to CMF.
  
  * Added date config to RifeConfig.

  * Added support for adding regular Participants to a BlockingRepository.

  * Added check that verifies if participants that are added to a
  BlockingRepository are of the correct type.

2004-08-31  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for JMagick as image content loader.
  
  * Added support for content emptying.

2004-08-30  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for ImageIO and JMagick for image loading in the CMF.

  * Minor bugfixes, code cleanups and test fixes.

2004-08-29  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added oracle support to CMF

  * Added support for firebird to CMF

2004-08-28  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added CMF support for HsqlDB, Mckoi, MySQL and Cloudscape.
  Oracle and Firebird are still unsupported.

2004-08-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed sql type bug where TIMESTAMP was used in MySQL instead of DATETIME

  * CMF source cleanups and unittests additions.
  
2004-08-26  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadocs and unittests updates.

2004-08-25  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Integrated faster base64 encoder.

  * Added CMF tests

  * Additional CMF unittests and javadocs
  
2004-08-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Source cleanups and javadocs additions

2004-08-23  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Source cleanups.

  * Added unittests and javadocs.

2004-08-22  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadocs updates.

2004-08-21  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Code cleanups.
  
  * Added javadocs for OrdinalManager.

  * Renamed OrdinalManager methods: move -> update and
  insert -> obtainInsertOrdinal.

2004-08-20  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added some CMF tests and dao bugfixes.

2004-08-19  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added complete OrdinalManager tests.
  
  * Fixed some OrdinalManager bugs.
  
  * Parted OrdinalManager to all supported databases.

2004-08-18  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added ordinal manager tests for all databases.

  * Added PagedNavigation unittests and fixed the implementation a bit.

2004-08-17  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added licenses of all libs.
  
  * Upgraded some libs.

2004-08-16  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added missing files from CMF.
  
  * Updated build files.
  
  * Added some javadocs.

2004-08-14  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Integrated the core features of RIFE/CMF.
  
  * This still needs to be fully unittested and ported to the other databases.

  * Added support for redirect in ElementSupport

2004-08-12  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Null primitives fix

2004-08-11  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed some deprecated method calls.
  
  * Added support for ERRORS: decoration of the fallback error area in the
  validation builder.

  * Encoding related bugfix

2004-08-10  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Internal query source refactoring.

2004-08-09  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed getDefaultLanguage() bug in RifeConfig

  * Fixes and refactoring of WaitingImageObserver

2004-08-08  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for getEmbedProperties()

  * Added uncached element

  * Added element declaration conflict tests.

2004-08-07  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Test updates

  * Added IDEA project files

2004-08-06  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fix for continuations and JDK 1.5

2004-08-05  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added Xalan to make XML template transformation work with java 5.0.
  
  * Updated McKoi SQL for latest CVS additions.
  
  * Updated code for Clover.
  
  * Added some convenience java 5.0 related scripts.

  * Javadocs fixes

  * Added a hack to have proper Groovy support in template expressions

  * Updated a bunch of libs

  * Updated Ant

  * Updated clover

  * Build file updates

  * Added support for Cloudscape.

2004-08-04  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadoc updates

  * Build file updates

  * Resolved issue RIFE-85: Add support for McKoi SQL.

  * McKoi db configuration update

  * Added some embedded DBs configuration

  * Added preliminary support for Cloudscape.
  
  * Added support for InputStreamUser and ReadUser to correctly use
  InputStreams and Readers with databases and resource finders.
  
  * ResourceFinder getResource methods changed to useResource.
  
  * DbQueryManager executeGetFirst*Stream have been replaced by
  executeUseFirst*Stream.

2004-08-03  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Deadlock-related bugfixes

2004-08-02  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Regression bugfixes.

  * Loosened consistancy checks a bit.
  
  * Added support for setting transaction isolation levels.

  * Added preliminary support for DaffodilDB

  * Added more detailed declaration consistancy checks, still needs to be
  fully unittested.

2004-08-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for setValue("value", template) in templates

2004-07-31  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Deadlock bugfix.

2004-07-28  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * URL shortening fix.

  * Added configurable max visual URL length.

  * Gate updates to make it dynamically fetch the Site instance from the Rep
  at each request.

  * Test fixes and better handling of Config to preferences lists.

2004-07-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Classloader bugfixes
  
  * Now allowing + in email address.

  * Added support for getServerRootUrl

2004-07-25  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Engine classloader bugfixes.

  * Database connection pool bugfixes.

  * Upgraded Firebird JDBC driver.

2004-07-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added silencing IOException catch block when the outputstream is closed
  and flushed. There's no need for this exception to propagate since it's
  due to the fact that the visitor is not connected anymore.

  * Updated HttpUnit

2004-07-23  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Expression tag processor bugfix.

  * Code updates

2004-07-22  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added site structure declaration with Janino.

  * Added processor and builder support for Groovy site structures.

  * Minor bugfixes in processor error reporting.

  * Added Groovy builder support for defining site structures.
  
  * The default ElementInfo and Site ProcessorFactory now is MANUAL.
  
  * ProcessorFactories are now also looked up by filename extension in case
  no explicit identifier is provided.

  * The 'corexml' identifier has been renamed to 'xml'.

  * Improved error reporting in the Xml2Site and Xml2ElementInfo builder a
  bit.

2004-07-20  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added full support for Groovy in evaluate expression tags.
  
  * Note that the API has changed both for the templates and the elements.
    evaluateOgnlRoleUser -> evaluateExpressionRoleUserTags
    evaluateOgnlConfigTags -> evaluateExpressionConfigTags
    evaluateOgnlTags -> evaluateExpressionTags

  * Added support for Groovy template expressions.

2004-07-19  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Database fixes.
  
  * Added support for Janino class body scripts.

  * Upgraded a bunch of packages and dependencies.

  * Added full Firebird support

2004-07-18  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * In-progress support for FirebirdSQL.
  
  * Restructured database query unittests.
  
  * Fixed some minor bugs is the database api.
  
  * Made certain exceptions in the engine Response silently discarted since
  they are related to clients disconnecting before the end of the reponse
  stream.

2004-07-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Database fixes.

2004-07-14  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed some McKoi-related stuff.
  
  * Minor database fixes.
  
  * Minor fixes to HttpUtils and ElementContext forward()

2004-07-12  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Removed post/submission check.

  * Regression bugfix.

  * Redesigned HttpUtils.

  * Implemented RIFE-149: Query builders should support subselects better

2004-07-11  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Restructured query managers and added full support for HypersonicSQL.

2004-07-09  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * JDK 5.0 related fixes.

2004-07-08  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for SequenceValue queries.

  * Started adapting querymanagers to use 'generic' fallback.

  * Started adding specialized subselect methods to query builders.

2004-07-07  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * DB fixes.

  * Added HsqlDB support.
  
  * Still need to add drivers to authentication, scheduling and resources.

2004-07-06  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Initial McKoi SQL support, still experimental since many McKoi flaw still
  need a workaround or to be disabled.

2004-07-04  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated tests and other files to remove the naming of initparams and
  replace it with static properties.

  * Removed initparams and replaced them by static properties. The <initparam>
  tag has been replaced by the <property> tag.

2004-07-03  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Retrieve page updates and forward improvements.

  * Workaround for Jetty header bug

2004-07-02  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Optimized identified element.
  * Forward workaround for Jetty.

2004-07-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added LOCAL_FORWARD_PORT configuration parameter to make it possible to
  forward to a different port when the URL is local.

2004-06-30  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for forward() without relying on the servlet API since it
  doesn't take filters into account when doing forward. Implemented it from
  scratch through HttpUtils and updated the latter.

2004-06-29  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for defer().

2004-06-25  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added redirect support to flowlinks.

2004-06-21  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated bbcode url generation for URL shortening.

  * Defaulted URL encoding to ISO-8859-1

2004-06-17  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 0.7.2
  
2004-06-16  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for doSubmissionName() methods in an element that get
  called whenever a matching submission occurs.

2004-06-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed some bugs in WaitingImageObserver

2004-06-14  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added makeErrorValid() method to Validation.

2004-06-11  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Renamed ContentTransformer to TemplateTransformer to prevent a CMF
  name clash.

2004-06-09  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Replaced dateFormat() constraint with a more generic format()
  constraint. It now also ensures that the provided string is not only
  parseable, but also reversible, ie. a date can be parsed when it's not
  existent, however the resulting formatting of that date would then not
  be the same as the orginal input.

2004-06-02  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for redirecting to Element ids

2004-06-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Build file updates.

2004-05-29  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * JDK 1.5 beta2 related fixes

2004-05-28  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated for jdk 1.5.02-beta2

2004-05-20  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Implemented remember IDs purging.

  * Consistancy fix to all proper resource abstraction for Groovy
  scripts.

2004-05-19  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added ranged users listing to RoleUsersManager.

2004-05-18  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for custom java compiler arguments through the
  JAVA_COMPILER_ARGS config list.

2004-05-17  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for knowing if an authentication session was started
  with full credentials or through remembered data.
  
  * The authentication elements now support the 'prohibit_remember'
  initparam which enforces authentication sessions that actually
  validated complete credentials.
  
  * The authentication DB structure sadly changed, here are the changes
  to perform per database:

  MySQL:
  ALTER TABLE Authentication ADD COLUMN remembered BIT DEFAULT 0 NOT NULL;

  Oracle:
  ALTER TABLE Authentication ADD (remembered NUMBER(1) DEFAULT 0 NOT NULL);

  PostreSQL:
  ALTER TABLE Authentication ADD COLUMN remembered BOOLEAN;
  UPDATE Authentication SET remembered = false;
  ALTER TABLE Authentication ALTER COLUMN remembered SET NOT NULL;
  ALTER TABLE Authentication ALTER COLUMN remembered SET DEFAULT false;

2004-05-16  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fix for encoded labels.

  * Added authenticated(long userId) callback to the Authenticated
  element.

2004-05-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Reduced index name length since Oracle can get in trouble otherwise

  * Minor automatic input value replacement fix

2004-05-14  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated libs.

2004-05-12  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Simplified drastically authentication element database tests.

  * Made remember me cookie exist for 3 months.

  * Initial remember me support.

2004-05-07  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for direct template to bytecode compilation.

  * Made gzip compression configurable.

2004-05-06  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Implemented automatic and transparent text content gzip compression.

2004-05-05  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added exception that is triggered when an unopened tag is closed in
  a template

  * Upgraded mysql jdbc jar

  * Made datasource connection pools be cleaned up at repository
  cleanup.

2004-05-03  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Template bugfix to correctly handle templates classes that are
  loaded from jars where the original source location is also available
  on the filesystem.

2004-04-21  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 0.7.1
  
2004-04-20 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Examples updates.

2004-04-19 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadocs fixes.

2004-04-16 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for parametrizable limit and offset clauses in Select query
  builder.

2004-04-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * GQM api additions.
  
  * BBcode fixes.
  
2004-04-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added inList constraint support for float and double.
  
  * Added redirect element.
  
  * Added support for using the print template element with properties instead
  of init params.
  
2004-04-13  JR Boyens  <gnu-jrb[remove] at gmx dot net>

  * Added restoreFirst(RestoreQuery) to the GQM
  
  * Updated Hessian support
  
2004-04-08  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for defensive html encoding.
  
2004-04-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Made purging authentication the default authentication method.
  
  * Made BBCode URL conversion a bit more intelligent.
  
  * Authentication additions and refactoring.
  
  * Added listSessions to SessionManager.
  
2004-03-31  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fix to correctly support relative element ids in site definitions.

2004-03-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for URL localization.
  
2004-03-25  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added possibility to evaluation l10n and config tags explicitely.
  
  * Renamed evaluateOgnl to evaluateOgnlTags.
  
2004-03-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added template factory specific default resource bundles.
  
2004-03-22  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * NPE bug.

2004-03-19  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * GQM cache bugfix.
  
2004-03-16  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added getEmbedValue() ElementSupport method.
  
  * Added displayedRaw(boolean) constraint.
  
2004-03-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for cascading validation groups.

2004-03-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Changed roleusers manager retriever API.
  
2004-03-12  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for form field attribute setting through :ATTRIBUTES blocks.
  
2004-03-10  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Embedded element triggerlist bugfix.
  
  * Added reinitializeProperties to ValidationGroup.
  
2004-03-07  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Reworked transactions and added new recommended way of ensuring that code
  is executed in a transaction.
  
  * Database connection pool finalization fixes.
  
  * Updated buildfile for cgjavac which should be present in PATH to be
  picked up.
  
2004-03-06  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Element injection support and arrival id regression bugfix.
  
  * Introspection fixes for global exits.
  
  * Made ConstrainedProperty constraints integration more flexible in
  Validation.
  
  * Xml parsing tools flexibility improvements.
  
  * Added support for default content type specification.
  
  * Added support for file upload size exceeding detection.
  
  * Multipartrequest fixes.

2004-03-05  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added WaitingImageObserver.
  
  * Making sure that answer without a call functions as a regular return.
  
  * Continuation call fixes.
  
2004-03-04  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Various useful little additions.
  
  * Made identifier value retrieval public in GQM.
  
  * Made call continuation answer calls mandatory to resume to original
  continuation.

2004-03-02  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Optimized String encoding speed, amongst others html encoding.

2004-03-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Integrated and generified PCJ for speed improvements.
  
  * Added a concise log formatter.
  
  * Added support for template dependencies retrieval.

2004-02-29  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added Element and Sql debug tracing.
  
  * Added template cache map and integrated it with OGNL expression parsing
  caching.

2004-02-28  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for editable constraints.
  
  * GQM fixes.

2004-02-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added activateValidation() method.
  
  * Template content transformation bugfix.
  
  * Added convenience sitebuilder methods.

  * Added support for inspectable global exits.
  
  * Site structure introspection fixes.
  
  * Rep fixes.
  
  * Some site builder API convenience additions.
  
  * Added check to ensure that call() verifies that a flowlink is attached to
  the exit.

2004-02-26  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Some template engine changes to make it easy to construct a new template
  factory from an existing one.
  
  * Small fixes and changes to form building, engine and templates.

2004-02-25  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for SiteBuilder which allows alternative methods for site
  structure declaration, with immediate support for a java-only api.
  
  * manyToOne constraint fixes.

2004-02-23  JR Boyens  <gnu-jrb[remove] at gmx dot net>

  * Added a manyToOne constraint to create foreign keys automatically.
  
2004-02-23  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added field support to RestoreQuery.
  
2004-02-22  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 0.7.0
  
2004-02-21  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for RoleUsersManagerRetriever.

2004-02-20  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Add [img] support to StringUtils bbcode transformer.

2004-02-19  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed issue RIFE-144 : Rep file processing is sensitive to whitespace.

2004-02-18  Geert Bevin  (gbevin[remove] at uwyn dot com)
  * Added support for persistent and saved constraints.

  * Continuations bugfix and improved control flow analysis.

2004-02-16  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Engine refactoring and call fixes to restore the element state after an
  answer.

  * Made ValidationError cloneable.

  * Bugfix to Identified element to ensure that users are only recognized if
  they have a valid session going on.

2004-02-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added GenericQueryManagerDelegate class for easy creation of customized
  Generic Query Managers.

  * Added support for customizable count queries in GQM.

  * Added support for multi-line OGNL statements.

2004-02-14  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Embedded input preservation fixes.

  * Logout element fixes.

  * Fixed embbedding element problem with preserving embedder's inputs.

2004-02-12  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed private method continuations bug.

  * Made each Repository provide properties which should be used to collect
  application-wide properties in.

  * ConfigSelector* and DatasourceSelector* are replaced by XmlSelector*

  * Fix to auto-reload groovy files that are present in the implementations dir.

  * Added support for xml selectors in Memoryscheduler.

  * Added mandatory support for properties in the Repository.

  * Created and integrated a new RifeLifecycle class.

  * Extracted xml selectors in a common package.

2004-02-11  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added XmlSelectorProperty to select an XML file according to the
  rife.application property.

  * Purging bugfix for MemorySessions.

  * Made the BlockingRepository and BlockingParticipant more robust.

  * Added Rep tests.

2004-02-10  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Generic Query Manager fixes.

  * Refactoring according to RIFE-140 : The GQM is dependant on an integer
  indentifier method

  * Optimized GQM shortname creation.

  * Minor example fix.

2004-02-09  JR Boyens  <gnu-jrb[remove] at gmx dot net>

  * Fix for RIFE-141 : The GQM's method for determining table/sequence names
  doesn't work on inner classes
  
2004-02-09  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 0.6.59
  
2004-02-08  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for template initializers that are automatically called when
  the template is instantiated and when it's reset through the clear() method.
  
  * Made numberguess example runnable from Codeguide again.
  
  * Javadoc updates.
                                                                                
  * Added a small convenience participant abstract base class.
                                                                                
2004-02-06  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Removed softreferences to store continuation contexts since they cleared
  them away much too early. Another worst case scenario should be investigated
  since this just cleared the context at the slightest memory increase.
  
  * Added some continuations unittests.
  
  * Bugfix to appropriate create a canonical element id for arrival elements.

2004-02-05  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Made embedded element processing early instead of late.
                                                                                
  * Modified bean setting behaviour in templates. When a property value is
  null, it'll set an empty string, not disregard the property anymore.

  * Added support for evaluating template ognl expressions explicitely.

  * Made the collection of bean instances in DbBeanFetcher optional.
                                                                                
2004-02-04  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Made Swing Command classes always being called in seperate threads from
  actions.
                                                                                
2004-02-03  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadocs additions.

2004-02-02  JR Boyens  <gnu-jrb[remove] at gmx dot net>

  * Finalized unittests for the generic query manager.
                                                                                
2004-02-02  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for setting expression vars in templates through the
  setExpressionVar method.

  * Added support for automatic WEBAPP:ROOTURL value replacement through the
  Element's print method. This is typically used with
  <base href="[!V 'WEBAPP:ROOTURL'/]" /> to make it possible for relative URLs
  to always work.
                                                                                
2004-02-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for a rife.webapp.path system property to force which paths
  are interpreted as rife paths for the classloader.
                                                                                
2004-01-30  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Embedding / inheritance bugfix.
                                                                                
2004-01-29  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for "implementations/" default dir for the element
  implementations. This allows implementation source files to sit in a
  seperate hierarchy from the other application files. Note that this has no
  influence on the loading of already compiled class files.
                                                                                
2004-01-29  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed issue RIFE-138 : Manually evalutating OGNL blocks is not currently
  supported with the addition of a evaluateOgnlUser(Template, String) method.
                                                                                
2004-01-28  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed continuations in an inheritance structure.

  * Added element instance property setting through <property> tag in site
  structure.

  * Fixed issue RIFE-136 : RIFE needs a passthrough authentication element by
  adding an Identified element.

  * Made setRequestAttribute and removeRequestAttribute accessible from within
  the childTriggered method.

  * Fixed bug RIFE-137 : Arrival declaration can workaround authentication
 
2004-01-27  Geert Bevin  (gbevin[remove] at uwyn dot com)
 
  * New implementation of new control flow analysis for continuations.
 
2004-01-26  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Optimized continuations bytecode instrumentation a bit.

  * Minor fixes to the construction of urls with pathinfo.

  * Added support for automatic input checkbox, radiobutton and select
  generation.

  * Added support for named global beans.

  * During submission inputs are now preserved in a serialized form to that they
  can be overridden by newly submitted query parameters.
 
2004-01-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Made continuations work with Codeguide's new back-in-time debugger by
  forcing the processElement method to be debugged in a regular fashion.
 
2004-01-23  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Made form building and contrained build usage adapt to non-instantiatable
  classes.

  * Made DTDs more permissive.
 
  * Fixed issue RIFE-135 : Whitespace is significant in template directive(s)
 
2004-01-22  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Removed revalidate method from Validation to prevent confusion.

  * Solved issue RIFE-125 : Allow inter-element continuations
 
2004-01-21  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Resolved issue RIFE-133 : RIFE needs a confirmation Constraint
 
  * Integrated and optimized listUserRoles database queries.

  * Added a feature that detects dots in query parameters so that they can be
  prefixed with table or tablespace without polluting the parameter name.
 
  * Fixed issue RIFE-134 : Authid cookies need to be set at /
 
2004-01-20  JR Boyens  <gnu-jrb[remove] at gmx dot net>

  * Added a way to list all the roles that a user has
 
2004-01-18  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Refactored the repository and updated the javadocs. The only incompatible
  difference is that participants that extended RepParticipant before now have
  to extend BlockingParticipant.
 
2004-01-17  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added ValidationGroup unittests.
 
  * Add support for generating form field labels through ResourceBundles.
 
  * Made precedence and embedded incookies also transfer, not only global
  cookies since RIFE doesn't handle the cookies state transfer internally, it's
  done by the browser.
 
2004-01-16  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed bug where a global cookie set by an embedded element didn't appear in
  other embedded elements.
 
  * Updated query builders to better support nulls in wheres.

  * Rep documentation updates.
 
2004-01-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Made target-specific compilation error reporting better.
 
  * Fixes to make things work better on windows.
 
2004-01-14  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Resolved issue RIFE-97 : Provide blueprint implementations of common
  approaches by extending the DbQueryManager.
 
  * Implemented ValidationGroup support

2004-01-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Small fixes and trivial changes to make more stuff work with the java 1.5
  alpha release.
 
2004-01-12  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updates and hacks to be able to generate javadocs with the gcj v2.2
  pre-release.
 
  * Added workaround for IBM's JVM to the engine classloader
 
  * Additional DbQueryManager features and integrated them all over RIFE.
 
  * Changed the where methods of the query builders so that whereAnd() and
  whereOr() are used as where() when they're the first instructions.

2004-01-11  JR Boyens  <gnu-jrb[remove] at gmx dot net>

  * Major changes to the GenericQueryManager

  * Added support to the GQM for modifying the underlying queries and still
  retaining integrity.
 
2004-01-11  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for auto element id generation when the id is omitted during
  element definition.

2004-01-09  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Implemented the validation error marking.
 
2004-01-08  JR Boyens  <gnu-jrb[remove] at gmx dot net>

  * Added support for partial queries and merging of said queries.
 
2004-01-07  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added further support for groovy.

  * Resolved issue RIFE-130 : Add support for FORM:HIDDEN in the form builder.

2004-01-06  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added OGNL roleuser support.

  * Added OGNL support in the template engine to conditionally set values to
  blocks.
 
2004-01-04  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Implemented validation error generation in form builder.
 
2004-01-03  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Changed template tag filtering to consume all substring matches and don't
  enforce matching a whole line anymore.

  * Added support for template block tag filtering.
 
2004-01-02  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Validation updates and changes to friends example to integrate the new
  features.
 
  * Resolved issue RIFE-96 : Integrate validation rules in query builders and
  form formatters
 
2003-12-31  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Changed fetchAll of DbQueryManager so that it always returns true when rows
  are found and false if no rows were present in the resultset.

2003-12-30  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed issue RIFE-127 : MemoryUsers and DatabaseUsers lack the posibility to
  list users by a certain role
 
2003-12-30  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added removal of forms and fields to the form builder.

2003-12-29  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Implemented cloneable for a bunch of classes.

2003-12-28  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Integrated the form builder into the engine.
 
  * Added formbuilder support for select fields.
 
2003-12-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added form builder checkbox support.
 
  * Added form builder textarea support.
 
  * Added form builder radio button support.
 
2003-12-25  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Refactorings for the later implementation of form builders.
 
2003-12-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for a default value for ConstrainedProperty.

  * Added support for retrieval and presence checking of template default
  values.
 
  * Resolved RIFE-124 : SQL statements may have one or more UNION clauses.
 
2003-12-22  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Changed authentication method argument policy, instead of throwing
  IllegalArgumentException the methods now perform a logic default behaviour
  in case of invalid parameters.

  * Global cookie & global vars bugfix.
 
  * Added support for named submission beans.
                                                                                
  * Added support for template blocks inside default values.
 
2003-12-21  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for continuation cloning to keep previous contids working.
  The downside is that all instances in the element have to be cloneable, if
  this is a problem the developer can override the cloneContinuations() method
  or configure the behaviour through the setCloneContinuations(boolean) method.
  The behaviour will then be as before.
   
  * Made ElementSupport's initialize and childTriggered methods public.
 
2003-12-20  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Interfaced the Template class.

  * Integrated constrained properties with CreateTable queries.
 
2003-12-19  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Upgrade asm to 1.4.1
 
2003-12-17  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for limited subject errors.
 
2003-12-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for elements that implement the ElementAware interface,
  element can thus be any class now as long as the correct interface is
  implemented.
 
2003-12-14  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated clover script.
 
  * Started the implementation of intelligent validation and constraints
  framework.

  * Added prepared statement parameter setting chaining.
 
2003-12-11  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updates so that state stores are able to encode any RIFE url.
 
2003-12-10  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Implemented RIFE-93 : Add support for server-side storage
 
2003-12-09  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Started implementing configurable state storage.
 
2003-12-07  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Implemented per-request continuation ID instead of per-request continuation
  context.
 
  * Optimized garbage collection for continuation context by using the
  reference api.
 
2003-12-05  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed issue RIFE-122 : Continuation contexts should be unique for each
  request.

  * Renamed pauze() to pause()

  * Added ObjectUtils with methods to facilitate deep and shallow cloning.
 
2003-12-04  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed RIFE-42 : Don't allow global exit overrides in group hierarchies
 
2003-12-03  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added preventCaching() method to Element.
 
  * Fixed issue RIFE-120 : A destid of "." will cause an assertion failure
 
2003-12-02  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed issue RIFE-119 : Continuations break when used with embedded elements
 
  * Refactored the GQM restoreWhere 'linkName' parameter to 'field' since that
  read much more intuitively.
 
  * Fixed some embedded element bugs related to encoding and buffered
  writing/printing.
 
2003-12-01  JR Boyens  <gnu-jrb[remove] at gmx dot net>

  * Added restoreWhere functionality for more datatypes

  * Added tests for bean inheritance
 
2003-12-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added all required JVM encodings to the ones that are cached by the template
  engine.
 
  * Fixed issue RIFE-116 : Embedded element contents shouldn't use the response
  encoding
 
2003-11-30  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Put ASM in different package to prevent clashes.
 
2003-11-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 0.6.58

2003-11-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 0.6.57

  * Examples updates and javadoc fixes.

  * Continuation fixes for javac's compiled finally blocks.

2003-11-26  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Made DatabaseExceptions unchecked.

  * Fixed issue RIFE-113 : Continuations should work in try-catch-finally
    statements

2003-11-25  JR Boyens  <gnu-jrb[remove] at gmx dot net>

  * Added a MySQL driver to the GenericQueryManager

2003-11-25  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Generic query managers updates + oracle driver.

  * Added JR Boyens' generic query manager.

  * Add continuations tests and fixed some bugs.

  * Resolved issue RIFE-99 : Add final parameter to config settings

  * Fixed exception reporting in case of compilation failure.

2003-11-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed issue RIFE-103 : Inheritance related bug breaks embedded element
    submissions

2003-11-23  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed RIFE-110 : TemplateFactory.TEXT is not consistent with the
    template extension

  * Resolved issue RIFE-90 : Add tests for ElementService interface support
    in Hessian webservices

  * Fixed issue RIFE-4 : Extend engine element tests

  * Fixed issue RIFE-109 : Included config files don't have the parameters
    of the including file at their disposal

2003-11-21  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Made exception handling in the filter and servlet better to disregard
    the now top-level InvocationTargetException.

  * Completely reworked the engine's classloading and element instantiation
    to ensure that only one single point of class loading is available.
    This also restores the ability of elements to use package private access
    amongst classes within the same package.

2003-11-21  JR Boyens  <gnu-jrb[remove] at gmx dot net>

  * Added 4 new config options for previously unconfigurable database lengths

2003-11-21  F.A. Meijndert  <ferry[remove] at silverback dot nl>

  * Added removeUser(long userId) to MemoryUsers and DatabaseUsers

  * Added unittests for removeUser(long userId)

  * Refactored some names for consistency

2003-11-19  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Additional contiuation tests and fixes.

2003-11-18  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed RIFE-102 : Distribution files should extract to top-level directory

2003-11-17  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Upgraded postgres jar and added tested postgres 7.4.

  * Upgraded ASM and continuations bugfixes.

2003-11-17  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Re-implementation of continuation engine with better global execution
    flow analysis.

2003-11-14  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for request element tracing with optional memory info output

2003-11-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Replacement of query initialization pattern with one that works correctly
    in a multi-threaded env.

2003-11-12  JR Boyens  <gnu-jrb[remove] at gmx dot net>

  * Added config params for common unconfigureable options

2003-11-10  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added boolean initparam test.

  * Elementcontext print updates.

  * Solved issue RIFE-95 : Test DbQueryManager fetchAll method

2003-11-08  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Integrated jboyens' patch for issue RIFE-63 : Add support for global
    cookies

2003-11-07  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added configurable template type to the logout element.

  * Fixed spelling error in the api of TaskManager.

  * Extended the template deployer to make it possible to preload classes,
    include and exclude files.

  * Added multiple includes and excludes functionality to the getFileList
    method.

  * Added methods to check if a string filters through a series of including
    and excluding regular expressions.

2003-11-06  JR Boyens  <gnu-jrb[remove] at gmx dot net>

  * Implemented GlobalCookies

2003-11-06  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added method fillSubmissionBean to fill in submission parameters in an
    already existing bean.

  * Made all element methods that return collections or arrays return an empty
    object instead of null in case of no results.

  * Added support for global scope element id referencing for inheritence and
    precedence.

  * Renamed hasValue(id) to isValueSet(id) in the template API since it was
    easy to confuse it with hasValueId(id).

  * Template engine updates to make the ids of values that need to be set more
    restrictive and the content more liberal, ie. null is accepted.

  * Made all Stringutils methods stop throwing exceptions and behave
    reasonably in case of null arguments.

2003-11-03  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor change to parameter retrieval in elements. They can now be retrieved
    when there's no submission present, but a check will still
    be made if they are part of one of the available submissions.

2003-10-31  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed embedded element bug where it didn't respond well to inheritance
    with cookies and submissions.

2003-10-30  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added continuation purging.

  * First integration of continuations.

2003-10-28  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixes to make it compile with JSR-014 v2.2.

  * Build file fixes.

2003-10-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed issue RIFE-101 : Fall back to handler /foo if /foo/ handler doesn't
    exist.

2003-10-23  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed issue RIFE-100: Exit handling in an embedded element is broken.

2003-10-20  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Bugfix in the cleanup of the DbResultSet resultset.

2003-10-18  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Changed default scheduler sleep time to 500 ms instead of 60000 since
    otherwise it's not second-precise and minute-precise frequencies don't work
    correctly.

  * Added fetchAll() method in DbQueryManager.

2003-10-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Adapted dialogs to use JLabel by default instead of JMultiLabel since it
    turns out that JLabel does multiple lines through the use of
    HTML :-/

2003-10-12  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added method to get a file's base name to go together with the method to
    get its extension.

  * Renamed database structure installation and removal error exceptions to be
    more specific.

2003-10-11  Geert Bevin  (gbevin[remove] at uwyn dot com)
  * Made most element methods public, restricting them to protected access was
    a na�ve design decision.

  * Added support to Hessian web services to optionally implement the
    ElementService interface to gain access to the request element inside the
    service.

2003-10-10  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * New versions of swing dialogs and JMultiLabel.

2003-10-06  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added tests for authenticated web services.

  * Implemented first propotype of continuations support.

2003-09-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 0.6.57

2003-09-17  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Implemented support for multiple rep participants of the same class but
    with different names.

  * Implemented support for repository cleanup and cleanup of the
    participants in the reverse order of the initialization.

2003-09-16  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added more resources unittests.

  * Database query bugfixes where classes of primitive types as bean
    properties weren't handled correctly.

2003-09-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added resources unittests.

2003-09-14  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Further resources implementation and wrote javadocs.

2003-09-11  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * com.uwyn.rife.tools.FileUtils additions.

2003-09-08  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Removed outdated and unused com.uwyn.rife.client package.

  * Initial restructuring of resource finding and writing in a dedicated
    package.

2003-09-07  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Re-arranged the template handling to solely rely on resource finders.
    This is the first step to allows templates to be stored in a database.

2003-09-06  Geert Bevin  (gbevin[remove] at uwyn dot com)

  *  Resolved issue RIFE-86 : Authentication and PrintTemplate are limited
    to the use of html Templates.

2003-09-05  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Bugfix to swing menu builder.

  * Upgraded Beanshell to v2.0b1.

  * Fixed removeRole support to rely foreign key constraints when
    appropriate.

  * Fixed mysql removeUser to manually remove all the role links for the
    removed user.

  * Backed out serialization support in database types since the reverse
    mapping was not implemented and unittests were not implemented.

  * Small scripting languages fixes.

2003-08-30  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support to Localization tool class to retrieve the Locale that
    is used by the other methods.

  * Added FileUtils method to obtain the extension of a file.

2003-08-22  JR Boyens  <gnu-jrb[remove] at gmx dot net>

  * Implemented removeRole().

2003-08-22  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added scripting engines abstraction to able able to support others
    beside BSF.

  * Added support for Hessian web services : http://www.caucho.com/hessian/

2003-08-16  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 0.6.56

  * RELEASE 0.6.55

  * Updated build file for latest generics release 2.2 so that javadocs can
    be built (foreach statements are simple stripped away so that the API can
    be processed by javadoc).

  * Minor regression bugfix to support orion 2.0.2 again.

  * Removed docs and put them in seperate repository.

2003-08-16  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Made some minor fixes to the datasources xml file name selector mechanism
    and unittests.

  * Implemented issue RIFE-81: Add support for <datalink srcoutbean=""
    dstinbean=""/> with the addition of named input and output beans.

2003-08-15  JR Boyens  <gnu-jrb[remove] at gmx dot net>

  * Implemented a DatasourcesSelector similar to the ConfigSelector

2003-08-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added workaround for swing oversight in the standard API where
    programmatic menu item selections don't trigger associated actions.

  * More thorough and more appropriate generification of bean-related methods.

  * Minor swing dialog updates.

2003-08-14  JR Boyens  <gnu-jrb[remove] at gmx dot net>

  * Updated to a more generics friendly approach. Will allow for no casting
    on the client side.

2003-08-14  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added LocalizedString class which allows to automatically keep strings
    up-to-date with the active default localization settings.

  * Cross-platform related bugfix.

  * Bugfix to support cloning in the AbstractPropertyChangeSupport class.

2003-08-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for custom implementations of RoleUser through the use of
    the RoleUserCredentials class.

  * If another class is used for the credentials managers that rely on role
    users, then the authenticated element should contain the "credentials_class"
    init parameter. It should contain the complete classname of the credentials
    class to use.

2003-08-12  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed long standing argument validation bug in DatabaseSessions.

  * Added convenience class so that it's possible to obtain support for bound
    properties by simply extending the AbstractPropertyChangeSupport class.

2003-08-11  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Internal RELEASE 0.6.55_pre4

  * Bugfix in template engine regarding the new blockvalue tags.

2003-08-10  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for sorted lists in a descending order.

  * Refactored list sorting class to be more generic.

2003-08-09  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Swing fixes.

  * Bugfix to store config lists in a predictable order to  the preferences
    backend.

2003-08-08  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Put tools exceptions in a dedicated package.

  * Added support for objects stored in the config through serialization.

  * Added typed list methods to Config.

  * Renamed storeXml() methods to storeToXml().

2003-08-07  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Internal RELEASE 0.6.55_pre3

  * Small swing additions.

  * First fix for issue RIFE-84 : Using beans with non-primitive fields causes
    SQL statement breakage.

  * Updated for jdbc driver aliases.

  * Implemented issue RIFE-78 : Support JDBC driver aliases in query
    construction classes

  * Added an alias for org.gjt.mm.mysql.Driver to com.mysql.jdbc.Driver and
    renamed org_gjt_mm_mysql_Driver support to com_mysql_jdbc_Driver.

  * Added support for a whole bunch of other look and feels.

2003-08-06  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added menu-related swing functionalities.

  * Updated build file to use generic types for beanshell support.

  * Removed support for netrexx.

  * Generified all remaining raw parts.

  * Swing-related code inspections, cleanups and refactorings.

2003-08-03  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Set correct method permissions.

  * Added look and feel detection class.

  * Updated swing api.

  * Added support for storing config settings as preferences and for setting
    a preference node that has a higher priority than the config to retrieve
    the parameter values from.

  * Added swing config settings.

2003-08-03  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Internal RELEASE 0.6.55_pre2

  * Removed block tag options and replaced OPT='DEFVAL' by a new BV tag.

  * Added filtered config value tag support (<!--V 'CONFIG:param'/-->) to all
    template configurations instead of just those that are instantiated through
    the web engine.

  * Added support for localization through ResourceBundle setting in
    templates.

  * Added dummy pass-through encoder as default template encoder instead of
    null.

2003-07-25  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Changed clone() methods to have appropriate covariant return types.
    While this makesnon-generic javadocs generation incorrect, it makes the
    life of generics-enabled developers much easier. In a generics-aware
    javadocs tool this should have been fixed.

2003-07-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Code updates after inspection.

2003-07-23  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Internal RELEASE 0.6.55_pre1

2003-07-18  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated for JSR-014 v2.2 release.

  * Updated build file to create a SOAP supporting war.

  * Added support for SOAP wsdd and admin services deployment.

  * Added SOAP-related tests.

  * Refactored jws soap features.

  * Elements can now have access to the raw element context or http request
    by overriding the prohibitRawAccess() method and returning false.

2003-07-18  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Integrated axis so that jws files are looked up by RIFE just as the other
    files (classpath)

  * Abstracted automated java file compilation and updated the current usages
    of it.

  * Added initial SOAP support through Axis.

  * Fixed xml entity resolving regression bug.

  * Prohibited almost all element methods now in child trigger context. Only
    getRemote*() will work.

2003-07-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for weblogic 8.1 and orion 2.0.2.

2003-07-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Minor fix to make RIFE work with the latest Resin.

  * Updated examples.

2003-07-11  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadoc fixes.

  * RELEASE 0.6.54

  * During the declaration of submissions one had to declare an id, while
      for all the other element properties a name attribute was used. This has
      now become name for submission too. ie:
      <submission id="..."/> -> <submission name=".."/>

2003-07-10  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Bugfixes and testcases for snapback datalinks.

  * Added initial support for snapback datalinks.

2003-07-09  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * The generateContent() method of the Element class has been replaced by
    processElement().

  * Restructuring of the database api related to the resultset. It's now
    completely wrapped to provide fail-safe and transparent us of
    hasResultRows().

  * Removed export of genericity in the _getObjects method of Rep
    participants.

2003-07-07  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Engine precedence fixes.

2003-07-04  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Correctly implemented manipulation of global vars through outputs in
    embedded or preceding elements.<!--V 'OUTPUT:var2'/-->

  * Example fixes.

  * Precedence fixes.

  * Passthrough logout element updated.

2003-07-03  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Converted Iterators and iterating for statements to the new foreach syntax
    of the upcoming JDK 1.5 release.

2003-07-02  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for inheritance and precedence in group declarations.

   * First working precedence implementation.

2003-07-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Implemented support for snapback and inheritance cancellation in global
    exits.

  * Added unittests for passthrough logout elements together with snapback
    flowlinks.

2003-06-29  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Created passthrough logout elements and renamed the previous logout
    elements to 'template' elements. Therefore, when having referenced
    rife/logout/database.xml one has to reference
    rife/logout/template/database.xml instead now.Template

  * Added flowlink snapback support.

  * Updated Codeguide project files for Sapphire.

2003-06-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Begun implementation of flowlink snapback support.

  * Multiple minor updates.

2003-06-20  Geert Bevin  (gbevin[remove] at uwyn dot com)

     * Increased testsuite code coverage.

2003-06-17  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Implemented issue RIFE-80 : Support template tag escaping.

2003-06-16  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Implemented issue RIFE-79 : Template reloading when a ContentTransformer
    changes.

  * Added support for target element retrieval in an inheritance structure.

  * Updated friends example to highlight erroneous fields.

2003-06-15  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added unittests for inheritance cancellation during flowlinks.

  * Updated inheritance example some more.

2003-06-14  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Examples cleanups and copyright updates.

   * Added support for inheritance control during flowlink declaration in site
    structure.

  * Minor refactorings.

  * Engine exceptions code review.

2003-06-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for post verification disabling in element.

2003-06-12  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 0.6.53

  * Bugfix where content flushes threw an exception when the user stopped or
    disconnecting the browsing session.

  * Fixed bug where the internal buffer was flushed, but the outputstream not.

2003-06-11  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Changed license to LGPL.

  * Consistently applied exception throw statements in method signatures, even
    for runtime exceptions.

  * Updated to clover 1.2.

  * Api updates.

2003-06-03  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Regression fixes to the examples.

  * RELEASE 0.6.52

  * Updated examples for additional template tag format.

  * Extended friends example by using beans.

  * Updated ContentTransformerXslt to support output properties setting.

2003-06-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for multiple template tag syntax configurations within the
    same parser. This is used to provide support for long invisible comment tags
    and convenient compact tags with the following syntax : [!V 'value'/],
    [!V 'value']default[/V], [!B 'block']content[/B], [!I 'include'/].
    These tags can also for example be used in XSLT stylesheets where invisible
    comments tags are not accepted, for example in href attributes.

  * Updated for new JSR-014 v2.0 so that it can be used to compile RIFE. The
    downside is that the latest JSR-014 release requires a runtime jar to be
    loaded in the bootstrap classpath of the virtual machine. This is
    cumbersome, but at least people are still able to compile RIFE themselves
    without CodeGuide.

2003-05-31  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Rewrite of XSLT transformer since using an XSLT stylesheet for it
    intervenes too much with the resulting output. It's now implemented as a
    Xalan element extension.
    Sadly this means that currently, the usage if <rife:value>, <rife:block> and
    <rife:include> tags will only work with the XSLT engine that ships with
    J2SE 1.4 or a compatible Xalan release.

2003-05-30  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for explicit processing of embedded elements to make it
    possible to process them in the correct order according to other explicit
    template value processors such as exit and submission query builders.

  * Added additional template retrieval methods inside an element which
    supports engine filtered values and setting of transformers.

  * Updated mysql-jdbc and ant contrib libs to their latest versions.

  * Minor API modifications and test additions.

2003-05-29  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added unittests for additional embedded behaviour.

2003-05-28  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for non-url embedded elements that can be perfectly
    integrated in templates. Their submissions will go to the first enclosing
    element with an url.

  * Added the fact the embedded element outputs modify the global variables
    of their inclosing context.

  * Added transformation template dependency reloading tests.

  * Xml storage related bugfixes and added unittests.

2003-05-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added convenience methods for storing XML-supporting datastructures to a
    data file. This has been done for MemoryUsers, Config and Datasources.

  * XML Resource finder bugfix where resources in jar files weren't found.

  * Added custom XSLT tags <rife:block>, <rife:value>, <rife:include> to
    easily generate tags that to template engine understands.

  * Restructured some of the template test cases.

  * Added template content transformers that are able to modify the content
    of a template file before the parser processes it.

  * Implemented an XSLT template content transformer.

  * Changed XML inputsource handling to correctly respect the encoding of the
    XML file. This is done both for the XML data file and the entity files.

2003-05-26  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixed design bug in template engine where setting a bean didn't overwrite
    existing values.

  * Added support for the removal of bean values from a template, this to go
    hand in hand with setting all the bean values.

  * Added performance enhancements to scripted java elements.

2003-05-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added testcase for externally used internal template values, typically
    used to handle recursion in templates.

  * Added support for using and maintaining an internal template construction
    value outside of a template.

  * Rearranged examples and added recursive template usage example.

2003-05-23  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Made the ExceptionErrorRedirector the default for all Xml2Data extending
    classes.

  * Implemented issue RIFE-77 : Improve XML error reporting.

2003-05-22  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Implemented issue RIFE-40 'Add support for element groups in the site
    definition'.

  * Fixed email validator to accept a '-' char in the domain name.

2003-05-19  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Template API consistancy regression bug fix.

  * RELEASE 0.6.51

  * Internal database thread deadlock bugfixes and performance optimizations.

2003-05-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Rewrote template engine and applied a lot of performance optimizations.

2003-05-06  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 0.6.50

  * Resolved issue RIFE-35 : Allow cookies to launch child triggers

  * Updated database api to support query builders everywhere where plain SQL
    strings are supported.

  * Unified api to eliminate the difference between regular queries and
    parametrized queries from a user's point of view.

2003-05-05  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Removed 'classname' and 'scriptname' attribute in element definition and
    replaced it by the 'implementation' attribute. This breaks backward
    compatibility but was implemented since it offers a very important
    transparent migration path from java scripted elements to pre-compiled java
    classes for production deployment.

  * Resolved issue RIFE-76 : Error message misleading when class cannot be
    found for element.

2003-05-04  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadoc updates.

  * Added very basic friends list tutorial example to demonstrate a website
    that is backed by a database.

2003-05-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Resolved issue RIFE-70 : Extend com.uwyn.tools.StringUtils convertBbcode()

  * Javadoc updates.

  * Updated the directory structure of the tutorial examples.

  * Added clover.

2003-04-30  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadoc updates.

2003-04-29  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadoc updates.

2003-04-28  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadoc updates.

2003-04-21  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadoc updates.

2003-04-14  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 0.6.49

  * Major design flaw fix where a DbQueryManager stores its connection, this
    is a source of bugs and bad usage.

  * Bugfix to datasource connection retrieval where a deadlock could occur
    when obtaining a connection in a transaction several times from the same
    thread.

2003-04-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Javadoc additions and minor api updates.

2003-04-10  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for xhtml and xml templates.

  * Added doctype to all example templates.

  * Example template updates to contain a head section.

  * Updated helloworld example.

  * Added support for disabling transaction timeouts and disabled them by
    default.

2003-04-09  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 0.6.48

  * Bugfix for issue RIFE-72 (Parent element of arrival element in subsite
    is wrongly resolved)

2003-04-08 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Mysql clone create table testcase fixes.

2003-04-07 Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Bugfix for issue RIFE-74 (Pathinfo is not preserved when the
    childrequest is encoded/decoded)

  * Bugfix for issue RIFE-73 (Root element url is empty instead of /)

  * Bugfix for issue RIFE-71 (Wrong exit query url generated in inheritance
    structure when there are no inputs available)

2003-04-05  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Helloworld example update to include a template.

2003-04-05  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixes to some access modifiers in the database query builder api.

2003-04-03  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 0.6.47

  * Bugfix to Delete query constructor to correctly support where
    parameter aliases.

2003-04-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Bugfix to the obfuscation string encryptor/decryptor.

  * Added support for parametrized unions in select query builder.

2003-03-31  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Bugfix to the configuration of the table and sequence names of
    authentication and scheduler (parallel installation).

  * Made query builders cloneable.

2003-03-30  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Template fix to remove all DCLs.

  * Template engine speed optimizations.

2003-03-29  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added sub select support to all parametrized query builders.

2003-03-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 0.6.46

  * Added better support for implicit boolean values conversion in helper
    methods.

  * Javadoc updates.

2003-03-26  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Fixes to remove double-checked locking applications (DCL) since
    it's flawed :
    http://www.cs.umd.edu/~pugh/java/memoryModel/DoubleCheckedLocking.html

2003-03-25  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated mysql jdbc driver.

  * Javadoc and api updates.

2003-03-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Implemented all datasource-related tests.

2003-03-22  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated jetty to v4.2.9 for the engine tests.

2003-03-14  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Numberguess example fixes.

2003-03-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Turned the getEncoder method of templates into a public method.

  * Added automatic creation of the temp path if it was automatically set
    by the Gate to be unique across servlet contexts.

  * Added support for Oracle under MacOSX in the unittest configuration.

2003-03-10  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated numberguess example to be more pertinent.

  * Added drawing of numberguess structure.


2003-03-07  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 0.6.45

  * Added simple tutorial examples.

  * Added adaptive classpath generation so that RIFE can auto-compile
    templates and elements with as much servlet engines as possible.

  * Bugfix to correctly get the classpath of the parent classloader to
    use for the compilation classpath setting.

2003-03-06  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 0.6.44

  * Bugfix to prevent duplication error output during the same request
    if the error occurred during the site initialization.

  * Bugfix to correctly obtain the compilation error message when an
    error occurred.

  * Bugfix to correctly obtain element and template compilation errors
    in all cases.

  * Bugfix where access to the rep participant's resourcefinders was
    wrongly prohibited after initialization.

  * Build fix where error html files were wrongly pregenerated as
    enginehtml files.

  * RELEASE 0.6.43

  * Regression bugfix where element generation path wasn't set
    correctly with a missing config file.

2003-03-05  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Integrated template precompilation in the build and release
    process.

  * Build file updates to prevent javac executable clash under *nix.

  * Updated ant test target to solely use the jar file for RIFE
    resources and classes.

  * Regression bugfix where the java compiler wasn't correctly
    selected.

  * Added support for resource content retrieval to ResourceFinder.

  * Refactored source for better ResourceFinder propagation.

  * Added support for template deployment and precompilation
    through the TemplateDeployer class.

2003-03-04  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added wasNull() method to the DbStatement class.

  * Regression bugfix where the temp path was incorrectly set.

  * Regression bugfix where element and template generation paths
    were incorrectly set.

2003-03-03  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 0.6.42

  * Added typed where parameters to query builders.

  * Updated task managers to use typed where statements in query
    builders.

2003-03-02  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for property value inclusion to config parameter
    definition.

2003-03-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated email validation rule.

2003-02-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added debugging info to auto-compiled java scripted elements.

  * Centralized retrieving of rife config values in a dedicated
    class.

  * Made authentication and scheduler database table names
    configurable.

  * Added basic database example.

  * Authentication fix to allow the updating of users without
    providing a password.

2003-02-26  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Internal scheduler install/remove refactoring for better code
    seperation.

  * Addition of method parameter checks and detection of duplicate
    role addition to authentication framework.

2003-02-25  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Removal of duplicate classes.

  * Windows related bugfixes.

  * Scheduler table name changes. Database schedulers will have to
    reinstall the database structure.

2003-02-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Updated for Jetty 4.2.8_01

  * Extension, refactoring, cleanup and unification of the
    authentication framework to handle all common tasks related to the
    management of RoleUser credentials.

  * Renamed getResultset() to getResultSet() in the DbStatement class.

2003-02-20  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 0.6.41

2003-02-13  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for adding users with already encrypted passwords
    to credentialsmanagers.

  * Upgraded and tested postgres jdbc jar v7.3.2

2003-02-12  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added delegation to other appropriate request methods.

  * Added multiple prepared sql statement parameter assignments and
    automatic assignments of all parameters with the same name.

2003-02-11  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Over-optimization bugfix where xml error redirectors were re-used
    between Xml2Data instances. This caused errors to persist in
    subsequent xml processings.

  * Bugfix where unicode characters were used for encoding urls, this
    has been changed to ISO-8859-1.

  * RELEASE 0.6.40

  * Introduction of FormFormatter to consistantly handle
    selected/checked/toggled form parameters.

  * Refactoring where HtmlFormatter was renamed to
    ValidationFormatter.

2003-02-10  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for setting template param values of multiple
    checkboxes with the same name.

  * Made template and element compilation work with the tools.jar
    of the ibm jdk.

  * Added more array conversion methods and made the ArrayUtils api
    less restrictive.

2003-02-07  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added full bean filtering for BeanUtils property count and name
    retrieval methods.

  * Added outputs bean clearing.

2003-02-06  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 0.6.39

  * Bugfix to ensure that each element declaration is correctly
    cloned. This caused arrival elements to have double parent
    stacks and thus parents to be executed twice.

  * Added typed cookie value retrieval methods.

  * Added support for config values in the datasource definitions.

2003-02-05  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added automatic bean-driven declaration of inputs, outputs,
    globalvars and submission parameters.

  * Added support for cookies in inheritance and authentication.

2003-02-04  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Split up authentication tests.

  * Added exceptions to rep to notify about invalid participants.

  * Bugfix where subsites without url prefix could cause for 'null'
    to appear in the url.

  * Added more explicit error reporting to the engine in case of a
    duplicate url.

  * Added support for input bean retrieval and name prefixes in
    getSubmissionBean.

  * Source quality evaluations and updates.

  * Added setting of bean values as outputs in the engine.

2003-02-01  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 0.6.38

  * Bugfix, scripted java elements didn't look up multiple-level
    packages correctly.

  * Major global refactoring where factory singleton methods got
    renamed from get() to getInstance().

  * Added support for setting bean in templates with support for
    select, radiobutton and checkbox html input types.

2003-01-31  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 0.6.37

  * Fixed rep.dtd so that participants are non-blocking by default.

  * Added element deployment support.

  * Added HtmlGenerator method to quickly set a collection of
    ValidationError subjects.

2003-01-30  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Made methods public that are useful for runtime element and site
    introspection.

2003-01-29  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added automatic parameter generation for checkbox input fields.

  * Added correct handling of bean submission generation from
    checkbox input fields.

2003-01-27  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added addition element parameters / inputs / files / outputs /
    globalvars conflict checks.

2003-01-26  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 0.6.36

  * Performed some code refactorings.

  * Added support for config value retrieval in xml site and element
    declarations, use the <config param=""/> tag.

  * Set UTF-8 as the compilation encoding.

  * Added StringEncryptor testsuite.

  * Upgraded jetty to 4.2.6 for engine tests.

  * Integrated encrypted authentication passwords with
    authentication elements.

2003-01-25  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * General speed optimizations by pre-allocating thread locks for
    repeated StringBuffer operations.

  * Bugfix where exits that are called from within an element that
    received a post submission caused the target element to think it
    received a post submission too.

  * RELEASE 0.6.35

  * Added convenience methods to retrieve arrays of typed submission
    parameters from within an Element.

  * Added ArrayUtils methods to convert string arrays to other
    primitive type arrays.

2003-01-24  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added argument validation to HtmlFormatter methods.

  * Implemented tests for groupBy(bean) method of Select queries.

  * Added XML_VALIDATION setting which can be used to globally
    disable/enable xml validation. By default the validation is
    enabled.

  * Renamed FILE_UPLOAD_PATH setting to FILEUPLOAD_PATH.

  * Cleanup and optimizations of scheduler and authentication
    database queries and their handling. All statements are now
    guaranteed to be closed, even when errors occurred.

  * Added encrypted password support to memory and database
    authentication. SHA-1, MD5 and Obfuscated algorithms are
    supported.

2003-01-23  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * Added support for inner classes in java scripted elements.

2003-01-22  Geert Bevin  (gbevin[remove] at uwyn dot com)

  * RELEASE 0.6.34
